﻿package
{
	import op.framework.OPLink;
	import op.framework.OpenFrameApplication;
	import op.utils.OPEvent;
	import op.external.OPTrace;
	
	import com.openpeak.controls.OPFBScrollPane;
	import com.openpeak.SoundItems.SoundItem;
	import com.openpeak.controls.StandardButton;

	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.events.MouseEvent;
	import flash.events.Event;
	
	import flash.net.URLRequest;
	import flash.events.IOErrorEvent;
	import flash.net.URLLoader;

	public class OPEXSound extends OpenFrameApplication
	{
		
		// config file
		public var _configXML:XML;
		
		// Scroll Pane
		public var soundPane:OPFBScrollPane;
		public var panel:Sprite;
		public var currentY = 5;
		
		// sound Objects
		private var _soundObjects:Array;
		
		function OPEXSound()
		{
		
			helpMessage.visible = false;
			closeButton.visible = false;
			
			soundPane = new OPFBScrollPane();
			soundPane.x = 10;
			soundPane.y = 65;
			soundPane.width = 760;
			soundPane.height = 310;
			
			panel = new Sprite();
			soundPane.source = panel;
			addChild(soundPane);
			
			var loader:URLLoader = new URLLoader( new URLRequest( "/openpeak/gui/apps/op_ex_sound/OPSound.xml") );
			loader.addEventListener( Event.COMPLETE, handleConfig );
			loader.addEventListener( IOErrorEvent.IO_ERROR, handleConfigError );
			
			var helpButton:StandardButton = new StandardButton();
			helpButton.lbl = "Help";
			helpButton.x = 645;
			helpButton.y = 15;
			addChild(helpButton);
			helpButton.addEventListener(MouseEvent.CLICK, showHelp);
			
			_soundObjects = new Array();
			
		}
		
		public function showHelp(e:MouseEvent):void {
		
			soundPane.visible = false;
			helpMessage.visible = true;
			closeButton.visible = true;
			
			closeButton.addEventListener(MouseEvent.CLICK, hideHelp);		
		}
		
		public function hideHelp(e:MouseEvent):void {
		
			soundPane.visible = true;
			helpMessage.visible = false;
			closeButton.visible = false;
			
			closeButton.removeEventListener(MouseEvent.CLICK, hideHelp);		
		}
		
		/**
		 * handleConfig
		 * 
		 * Parse the loader results
		 * @param	e Event loader event
		 */
		private function handleConfig(e:Event):void {
			
			_configXML =  XML(e.target.data);

			var color:Number;
			var c:int = 0;
			for each(var x:XML in _configXML.source){
				
				// determine which bg color
				if (c % 2 == 0) {
					color = 0x0000ff;
				}else{
					color = 0xffffff;
				}
				
				c++;
				
				// create a new SoundItem to display
				var tmp:SoundItem = new SoundItem(color,String(c));
				tmp.data = { label:x.@name, url:x.@url, type:x.@type };
				tmp.y = currentY;
				panel.addChild(tmp);
				
				// move down & update the scroll pane
				currentY = currentY + tmp.height + 10;
			    soundPane.update();
				
				_soundObjects.push(tmp);
			}
		}
		
		/**
		 * handleConfigError
		 * 
		 * hande the configuration error
		 * @param	e
		 */
		private function handleConfigError(e:Event):void {
			OPTrace.debug("failed to load config file: /media/OPSound.xml");
		}		
	
		
		/**
		 * unApplicationUnload
		 * 
		 * clean up all listeners and other resources
		 * 
		 * @param	e Event
		 */
		public override function onApplicationUnload(e:Event) {
			
			// clean up timers
			for (var i:uint = 0; i < _soundObjects.length; i++) {
				SoundItem(_soundObjects[i]).destroy();
			}
			
		}
		

	}
	
}