﻿package com.openpeak.SoundItems
{
	
	import com.openpeak.controls.StandardButton;
	import op.framework.OPSoundEvents;
	import op.external.OPTrace;
	import op.framework.OPLink;
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	
	

		
	/**
	 * SoundItem
	 */
    public class SoundItem extends Sprite
	{
		
		private var hitBox:Sprite;
		
		/**
		 * @private
		 */
		public var _data:Object;
		
		public var label:TextField;
		public var itemNumber:TextField;
		public var duration:TextField; 
		public var url:TextField;
		public var lastEvent:TextField;

		// buttons
		public var volButton:StandardButton;
		public var playButton:StandardButton;
		public var stopButton:StandardButton;
		public var volumeUpButton:StandardButton;
		public var volumeDownButton:StandardButton;
		
		public var labelFormat:TextFormat;
		public var itemCountFormat:TextFormat;
		public var durationFormat:TextFormat;
		public var lastEventFormat:TextFormat;
		
		// sound
		private var manager:*;
		private var soundObj:*;
		private var vol:int = 1;
		public var total:String;

		// duration
		private var statusTimer:Timer;

		public function SoundItem(color:Number, itemNum:String = "-" ):void
		{

			// this was addeds to ensure mouse events are fully captured by the cell
			hitBox = new Sprite();
			addChild(hitBox);
			
			// determine color
			hitBox.graphics.beginFill(color, .2);
			hitBox.graphics.drawRect(0, 0, 740, 100);
			hitBox.graphics.endFill();
			
			// label format
			labelFormat = new TextFormat();
			labelFormat.size = 22;
			
			// itemcount format
			itemCountFormat = new TextFormat();
			itemCountFormat.size = 54;
			
			// duration format
			durationFormat = new TextFormat();
			durationFormat.size = 35;
			
			// lastEvent format
			lastEventFormat = new TextFormat();
			lastEventFormat.size = 22;
			
			// label
			label = new TextField();
			label.defaultTextFormat = labelFormat;
			label.width = 200;
			label.autoSize = TextFieldAutoSize.LEFT;
			label.border = false;
			label.borderColor = 0xff0000;
			label.x = 25;
			addChild(label);
			
			// itemCount Format
			itemNumber = new TextField();
			itemNumber.defaultTextFormat = itemCountFormat;
			itemNumber.autoSize = TextFieldAutoSize.LEFT;
			itemNumber.border = false;
			itemNumber.borderColor = 0xff0000;
			itemNumber.x = 5;
			itemNumber.text = itemNum;
			addChild(itemNumber);
			
			// duration
			duration = new TextField();
			duration.defaultTextFormat = durationFormat;
			duration.autoSize = TextFieldAutoSize.LEFT;
			duration.border = false;
			duration.borderColor = 0xff0000;
			duration.x = 550;
			duration.y = 2;
			duration.text = "";
			duration.border = false;
			duration.borderColor = 0x000000;
			addChild(duration);
			
			// lastEvent
			lastEvent = new TextField();
			lastEvent.defaultTextFormat = lastEventFormat;
			lastEvent.autoSize = TextFieldAutoSize.LEFT;
			lastEvent.border = false;
			lastEvent.borderColor = 0xff0000;
			lastEvent.text = "";
			addChild(lastEvent);
			
			/** Buttons **/
			volButton = new StandardButton();
			volButton.y = 10;
			volButton.x = itemNumber.x;
			volButton.lbl = "Vol";
			volButton.visible = false;
			addChild(volButton);
			volButton.addEventListener(MouseEvent.MOUSE_DOWN, showVolume);
			
			playButton = new StandardButton();
			playButton.y = 10;
			playButton.x = itemNumber.x + itemNumber.width + 10;
			playButton.lbl = "Play";
			addChild(playButton);
			playButton.addEventListener(MouseEvent.MOUSE_DOWN,playStream);
			
			stopButton = new StandardButton();
			stopButton.y = 10; 
			stopButton.x = playButton.x;
			stopButton.lbl = "Stop";
			stopButton.visible = false;
			stopButton.addEventListener(MouseEvent.MOUSE_DOWN,stopStream);
			addChild(stopButton);
			
			volumeUpButton = new StandardButton();
			volumeUpButton.lbl = "+";
			volumeUpButton.visible = false;
			volumeUpButton.addEventListener(MouseEvent.MOUSE_DOWN,volumeUp);
			addChild(volumeUpButton);
			
			volumeDownButton = new StandardButton();
			volumeDownButton.lbl = "-";
			volumeDownButton.visible = false;
			volumeDownButton.addEventListener(MouseEvent.MOUSE_DOWN,volumeDown);
			addChild(volumeDownButton);
			
			url = new TextField();
			addChild(url);
		
			// position the label
			label.x = playButton.x;
			lastEvent.x = label.x + label.width + 10;
			lastEvent.y = label.y;
			
			// duration timers
			statusTimer = new Timer(1000);
			statusTimer.addEventListener(TimerEvent.TIMER, updateStatus);

		}

		
		
		public function set data(d:Object):void 
		{
			
			// reset some UI elements
			
			//save the data
			_data = d;
			
			// update the test
			label.text = d.label;
			
			// update the url
			url.text = d.url;
			url.x = label.x;
			url.y = label.y + label.height;
			url.autoSize = TextFieldAutoSize.LEFT;
			
			// update button position
			playButton.y = url.y + url.height;
			stopButton.y = url.y + url.height;
			volumeUpButton.x = stopButton.x + stopButton.width;
			volumeUpButton.y = stopButton.y;
			volumeDownButton.x = volumeUpButton.x + volumeUpButton.width;
			volumeDownButton.y = stopButton.y;
			
			volButton.x = volumeDownButton.x + volumeDownButton.width;
			volButton.y = stopButton.y;
			
        }
		
		public function volumeUp(e:MouseEvent):void {
			
			if (soundObj == null) {
				return;
			}
			
			if (vol == 100) return;
			
			vol++;
			if (vol > 100 ) vol = 100;
			
			soundObj.set_volume(vol);
		
		}
		
		public function volumeDown(e:MouseEvent):void {
		
			if (soundObj == null) {
				return;
			}
			
			if (vol == 0) return;
			
			vol--;
			if (vol < 0) vol = 0;
			
			soundObj.set_volume(vol);
		
		}
		
		
		
		public function onPlayComplete(e:*):void {
			
			lastEvent.text = "[complete]";
			positionEventStatus();
			statusTimer.stop();
			
			// Update the button states
			playButton.visible = true;
			stopButton.visible = false;
			volumeDownButton.visible = false;
			volumeUpButton.visible = false;
			volButton.visible = false;
		}
		
		public function onPlayStart(e:*):void {
			
			lastEvent.text = "[start]";
			positionEventStatus();
			statusTimer.start();
	
		}
		
		public function onPlayStop(e:*):void {
			
			lastEvent.text = "[stop]";
			positionEventStatus();
			statusTimer.stop();
		}
		
		public function onPlayError(e:*):void {
			
			lastEvent.text = "[error]";
			positionEventStatus();
			statusTimer.stop();
		}
		
		public function positionEventStatus():void {
			lastEvent.x = label.x + label.width + 5;
		}
		
		public function playStream(w:MouseEvent):void {
			

			// Update the button states
			playButton.visible = false;
			stopButton.visible = true;
			volumeDownButton.visible = true;
			volumeUpButton.visible = true;
			volButton.visible = true;
			
			

			if (soundObj == null) {
				
				// get a ref to the OPSoundManager
				try {
					var temp:Class = OPLink.classDefinition("media", "OPSoundManager") as Class;
					manager = Object(temp).getInstance();
				}catch (e:Error) {
					OPTrace.debug("[err=001] failed to get OPSound singleton:" + e.errorID);
				}
				
				
				// get a new sound object
				try {
					soundObj =  manager.getSoundObject();
				}catch (e:Error) {
					OPTrace.debug("[err=002] failed to get sound object:" + e.errorID);
				}
				
				if (soundObj == null) {
					
					lastEvent.text = "[no available channels]";
					positionEventStatus();
	
				}else {
					
				
					// add listeners
					try {
						OPTrace.debug("OPSound::ffplayItem adding listeners");
						soundObj.addEventListener(OPSoundEvents.PLAY_START, onPlayStart, false, 0, true);
						soundObj.addEventListener(OPSoundEvents.PLAY_STOP, onPlayStop, false, 0, true);
						soundObj.addEventListener(OPSoundEvents.PLAY_ERROR, onPlayError, false, 0, true);
						soundObj.addEventListener(OPSoundEvents.PLAY_COMPLETE, onPlayComplete, false, 0, true);
						
					}catch (e:Error) {
						OPTrace.debug("[err=003] failed to get sound object:" + e.errorID);
					}
				
				}
				
			}
			
				
			try {
				OPTrace.debug("[err=004] audsrv unique id: " + soundObj.getUniqueID());
				soundObj.load(_data.url);
				soundObj.set_volume(vol);
				soundObj.start();
				total = soundObj.get_duration();
			}catch (e:Error) {
				OPTrace.debug("audsrv failed to load url:" + e.errorID);
			}
			
			try{
				manager.status();;
			}catch (e:Error) {
				OPTrace.debug("failed to get status:" + e.errorID);
			}
			
			
		}
		
		public function stopStream(w:MouseEvent):void {
			
			OPTrace.debug("STREAM stopStream for: " + soundObj.getUniqueID() + " " + _data.url);
			volumeDownButton.visible = false;
			volumeUpButton.visible = false;
			volButton.visible = false;
			
			if (soundObj == null) {
				return;
			}
		
			// Update the button states
			playButton.visible = true;
			stopButton.visible = false;
			
			// stop the playback
			try {
				soundObj.stop();
			}catch (e:Error) {
				OPTrace.debug("audsrv failed to stop stream:" + e.errorID);
			}
			
			total = "";
			
		}
		
		
		private function updateStatus(e:TimerEvent):void {
			
			if ( soundObj == null ) return;
			
			var currentPosition:String = soundObj.get_current_position();
			
			if (total == "") {
				total = soundObj.get_duration();
			}
			
			if (int(currentPosition) < 0 || int(total) < 0) {
				duration.text =  "vol:" + String (vol) + " dur: 0 of 0 seconds";
				duration.x = 740 - duration.width - 10;
			}else {
				duration.text = "vol:" + String(vol) + " dur:" + soundObj.get_current_position() + " of " + soundObj.get_duration() + "sec";
				duration.x = 740 - duration.width - 10;
			}

		}
		
		public function destroy():void {
			
			OPTrace.debug("destorying sounditem");
			if(soundObj!=null){
				soundObj.addEventListener(OPSoundEvents.PLAY_START, onPlayStart, false, 0, true);
				soundObj.addEventListener(OPSoundEvents.PLAY_STOP, onPlayStop, false, 0, true);
				soundObj.addEventListener(OPSoundEvents.PLAY_ERROR, onPlayError, false, 0, true);
				soundObj.addEventListener(OPSoundEvents.PLAY_COMPLETE, onPlayComplete, false, 0, true);
			}
		}
		
		public function showVolume(w:MouseEvent):void {
			
			
			
			if (soundObj != null) {
				OPTrace.debug("show the volume control1");
				try{
					OPLink.loadVolumeControls(soundObj);
				}catch (e:Error) {
					OPTrace.debug("failed to show the volume controls:" + e.errorID + " " + e.message);
				}
			}else {
				OPTrace.debug("sound obj is null");
			}
			
			
		}
		
    }
}