﻿package com.openpeak.controls
{
	import fl.containers.ScrollPane;
	import flash.display.Sprite;
	import flash.display.DisplayObject;
	import op.external.OPTrace;
	import com.openpeak.controls.OPFBBaseScrollPaneTheme;
	/**
	 * Skinned version of the fl.containers.ScrollPane component
	 */
	public class OPFBScrollPane extends OPFBBaseScrollPane
	{
		/**
		 * A theme may be set in the constructor by passing a value from the OPBaseScrollPaneTheme class.
		 * 
		 * @param	theme
		 */
		public function OPFBScrollPane(theme:String = OPFBBaseScrollPaneTheme.LIGHT):void
		{
			super(new ScrollPane(), theme);
			_so.setStyle("upSkin", new Sprite());
			_renderBackground = false;

		}
		
		/**
		 * Gets the count of bytes of content that have been loaded.
		 */
		public function get bytesLoaded():Number { return scrollPane.bytesLoaded; }
		
		/**
		 * Gets the count of bytes of content to be loaded.
		 */
		public function get bytesTotal():Number { return scrollPane.bytesTotal;}
		
		/**
		 * Gets a reference to the content loaded into the scroll pane.
		 */
		public function get content():DisplayObject { return scrollPane.content; } 
				
		/**
		 * Reloads the contents of the scroll pane.
		 */
		public function refreshPane():void
		{
			scrollPane.refreshPane();
		}
		
		/**
		 * Reference to the contained fl.controls.ScrollPane instance
		 */
		public function get scrollPane():ScrollPane { return _so as ScrollPane; }
		
		/**
		 * Gets or sets an absolute or relative URL that identifies the location of the SWF or image file to load,
		 * the class name of a movie clip in the library, a reference to a display object, or a instance name of 
		 * a movie clip on the same level as the component.
		 */
		public function get source():Object { return scrollPane.source; }
		
		/**
		 * @private
		 */
		public function set source(value:Object):void
		{
			scrollPane.source = value;
		}
		
		/**
		 * Refreshes the scroll bar properties based on the width and height of the content.
		 */
		public function update():void
		{
			scrollPane.update();
		}
		
	}
	
}