package com.openpeak.controls 
{
	/**
	 * ...
	 * @author ...
	 */
	
	import op.external.OPTrace;
	
	public class OPGestureConstants
	{
		private static var _friction:Number;			//Amount of easing for flinging. Lower = slower animating
		private static var _drag_threshold:Number;		//Distance in pixels to accept before beginning drag handling
		private static var _drag_strength:Number;		//Used to amplify the strength of a fling
		private static var _rest_threshold:Number;		//Distance from destination until fling animation snaps
		private static var _poll_count:Number;
		private static var _dragBoost:int = 75;         // for consecutive swipes accelerate the scroll by this amount
		private static var initialized:Boolean = false;
		public static function init():void
		{
		
				_friction = .09;
				_drag_threshold = 10;
				_drag_strength = 6;
				_rest_threshold = 2;
				_poll_count = 5;				
			
				initialized = true;
			
		}
		public static function get FRICTION():Number { return _friction };
		public static function get DRAG_THRESHOLD():Number { return _drag_threshold };
		public static function get DRAG_STRENGTH():Number { return _drag_strength };
		public static function get REST_THRESHOLD():Number { return _rest_threshold };
		public static function get POLL_COUNT():Number { return _poll_count };
		
		/* customized values */
		public static function getCustomValue(profile:String = "",value:String = ""):Number {
		
			// initialize
			if (!initialized) init();
			
			switch(profile) {
				
				case "slow":
					
					switch(value) {
						
						case "FRICTION":
							return .4;
						break;
						
						case "DRAG_THRESHOLD":
							return 10;
						break;
						
						case "DRAG_STRENGTH":
							return 6;
						break;
						
						case "REST_THRESHOLD":
							return 2;
						break;
						
						case "POLL_COUNT":
							return 5;
						break;
						
					}
				break;
				
				default:
					
					switch(value) {
						
						case "FRICTION":
							return FRICTION;
						break;
						
						case "DRAG_THRESHOLD":
							return DRAG_THRESHOLD;
						break;
						
						case "DRAG_STRENGTH":
							return DRAG_STRENGTH;
						break;
						
						case "REST_THRESHOLD":
							return REST_THRESHOLD;
						break;
						
						case "POLL_COUNT":
							return POLL_COUNT;
						break;
						
					}
			}
			
			return 0;
		}
		
		/**
		 * The default value for drag boost
		 */
		public static function get DRAG_BOOST():Number { return _dragBoost; }
	}

}