﻿package op.extensions.phone
{	
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundMixer;
	import flash.media.SoundTransform;
	import op.external.OPTrace;
	import op.framework.OPLink;
	import op.framework.OPMedia;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	
	public class Account
	{
		private var isRinging:Boolean = false;
		private var m_lines:Array;
		private var m_type:String = "";
		private var m_provider:String = "";
		private var m_user:String = "";
		private var m_numberOfLines:String = "";
		private var m_online:Boolean = false;
		private var ringname:String = "";
		private var m_featureManager:* = null;
		private var RINGTONES_FILE_URL:String = "./ringtones.xml";
		private var FAILSAFE_RINGTONE_PATH:String = "./ring.mp3";
		private var m_selected:String = "";
		private var m_default:String = "";
		private var m_contactring:String = "";
		private var m_utils:* = null;
		private var m_player:* = null;
		private var m_ringtoneVolume:Number = -1;
		private var manager:* = null;
		private var soundObj:* = null;
		
		public var getState:Function;
		
		public function Account() {
			OPTrace.informational("Account::Constructor");
			m_lines = new Array();
			
			var ldr:URLLoader = new URLLoader();
			ldr.addEventListener(Event.COMPLETE, onComplete, false, 0, true)
			ldr.load( new URLRequest("./config.xml") );
		}
		
		private function onComplete(e:Event)
		{
			//OPTrace.debug("Account::Ringtone::onComplete");
			var config:XML = new XML(e.target.data);
            if (config.child("ringtones_xml")[0] != null)
                RINGTONES_FILE_URL = config.ringtones_xml;
            if (config.child("failsafe_ringtone")[0] != null)
                FAILSAFE_RINGTONE_PATH = config.failsafe_ringtone;
		}
		
		/* NOTE: RINGTONES ARE NOT LOADED IF THERE IS AN ERROR, THUS A NEW SOUND IS CREATED EACH TIME */
		// Once load() is called on a Sound object, you can't later load a different sound file into that Sound object. 
		// To load a different sound file, create a new Sound object.
		/* Ringtones are loaded in the following order:
		 * 1. Read ringtones.xml (fail -> load failsafe from config.xml)
		 * 2. Load contact ringtone if exists (fail -> load selected)
		 * 3. Load selected ringtone if exists (fail -> load default)
		 * 4. Load default ringtone if exists (fail -> load failsafe)
		 * 5. Load failsafe ringtone (fail -> play nothing)
		 */
		
		public function loadRingtones(s:String = "") {
			OPTrace.debug("Account::loadRingtones");
			OPTrace.debug("ringname: " + s);
			// klee - m_ringback = new Sound();
			m_selected = "";
			m_default = "";
			m_contactring = "";
			ringname = s;
			
			var ldr:URLLoader = new URLLoader();
			ldr.addEventListener(Event.COMPLETE, setRingtones, false, 0, true);
			ldr.addEventListener(IOErrorEvent.IO_ERROR, loadFailsafe);
			
			try {
				ldr.load( new URLRequest(OPLink.commonDirectory + RINGTONES_FILE_URL) );
			} catch (e:Error) { 
				OPTrace.debug("Cannot load ringtones file. Using failsafe.");
			}
			OPTrace.debug("Account::loadRingtones complete");
		}
		
		private function setRingtones(e:Event) {
			//Handle corrupted xml file bug #6003
			try {
				OPTrace.debug("Account::setRingtones");
				var ringtoneData:XML = new XML(e.target.data);
			} catch (e:*) {
				OPTrace.informational("ringtones.xml contains invalid XML (error=" + e.toString() + ").  Using failsafe.");
				loadFailsafe(new IOErrorEvent("Unable to parse XML"));
				return;
			}

			for each (var file:XML in ringtoneData..file) {
				if ( file.name == ringname ) {
					m_contactring = file.path;
					ringname = "";
				}
				if ( file.selected == "true" ) {
					m_selected = file.path;
				}
				if ( file.default == "true" ) {
					m_default = file.path;
				}
			}

			try {
				m_ringtoneVolume = ringtoneData.volume[0].@value;
			}
			catch (e:*) {
				m_ringtoneVolume = -1;
			}

			OPTrace.debug("ringtoneVolume: " + m_ringtoneVolume);
			OPTrace.debug("contactringer: " + m_contactring);
			OPTrace.debug("selected: " + m_selected);
			OPTrace.debug("default: " + m_default);
			
			if ( m_contactring != "" ) {
				OPTrace.debug("contactring");
				//klee - m_ringback.addEventListener(IOErrorEvent.IO_ERROR, loadSelected);
				//klee - m_ringback.load(new URLRequest(m_contactring));
				loadRingTone(m_contactring);
				startRingback();
				OPTrace.debug("contactring complete");
			}
			else {
				loadSelected();
			}
		}
		
		private function loadSelected(e:* = null) {
			OPTrace.debug("loadselected");
			isRinging = false;
			loadRingTone(m_selected);
			startRingback();
			OPTrace.debug("loadselected completed");
		}
		
		private function loadDefault(e:IOErrorEvent) {
			OPTrace.debug("loaddefault");
			isRinging = false;
			loadRingTone(m_default);
			startRingback();
			OPTrace.debug("loaddefault completed");
		}
		
		private function loadFailsafe(e:IOErrorEvent) {
			try {
				isRinging = false;
				startRingback();
			} catch (e:Error) { OPTrace.debug("Cannot find failsafe"); }
		}

		public function startRingback()
		{
			
			OPTrace.debug("PHONE::startRingBack::State::: " + this.getState());
			
			/** If the line is already connected, DO NOT RING **/
			if (this.getState() == Line.STATE_CONNECTED) {
				OPTrace.debug("PHONE::startRingBack::LINE ALREADY CONNECTED - NOT RINGING!!!!!!");
				return;
			}
			
			if( !isRinging ) { 
				
				//Set the ring volume appropriately if one was set in the ringtones.xml file
				if (m_ringtoneVolume != -1)
				{	
						
					if (m_utils == null)
					{	
						//define m_utils instance
						var SystemUtils:Class = OPLink.classDefinition("system", "SystemUtils") as Class;
						m_utils = new SystemUtils();
					}
					
					if (initSound()) {
						soundObj.set_volume(calculateVolume(m_ringtoneVolume));
						soundObj.loop = true;
						soundObj.start();
					}
                                                                
				
				}
				
				isRinging = true;
			}
		}
		
		public function stopRingback()
		{
			
			if( isRinging ) {

				try { 
					
					isRinging = false;

					//Change the volume settings back to what they were if we used a ring volume
					if (m_ringtoneVolume != -1)
					{
						
						if (initSound()) {
							soundObj.stop();
						}
					
						m_player.set_volume(calculateVolume(m_utils.mediaVolume));
						
					}
				}catch (e:Error) { 
					OPTrace.debug("Account::stopRingback::error msg::" + e.message); 
				}
			}
		}
		

		
		public function initSound():Boolean {
			
			// get a ref to the OPSoundManager
			if (manager == null) {
				
				try {
						 
					var temp:Class = OPLink.classDefinition("media", "OPSoundManager") as Class;
					manager = Object(temp).getInstance();
				
						
				}catch (e:Error) {
						OPTrace.debug("Phone::Account - failed to get sound manager object:" + e.errorID);
						return false;
				}
				
			}
			
			if ( soundObj == null) {
				
				try {
					soundObj = manager.getSystemObject(0);
				}catch (e:Error) {
					OPTrace.debug("Phone::Account - failed to get sound object:" + e.errorID);
					return false;
				}
				
			}
			
			return true;
			
		}
		
		public function loadRingTone(path:String):void {
		
			initSound();
			
			// load the sound		
			soundObj.load(path);
			
		}
		
		
		public function get type() : String { return m_type; }
		public function set type(t:String) { m_type = t; }
		
		public function get provider() : String { return m_provider; }
		public function set provider(p:String) { m_provider = p; }
		
		public function get user() : String { return m_user; }
		public function set user(u:String) { m_user = u; }
		
		public function get numberOfLines() : String { return m_numberOfLines; }
		public function set numberOfLines(n:String) { m_numberOfLines = n; }
		
		public function get lines() : Array { return m_lines; }
		public function set lines(l:Array) { m_lines = l; }
		
		public function get online() : Boolean { return m_online; }
		public function set online(o:Boolean) { m_online = o; }
		
		public function get featureManager() :* { return m_featureManager; }
		public function set featureManager(f:*) { m_featureManager = f; }
        
        private function calculateVolume(inputValue:Number):Number
        {
            var volume:Number;
            //Input value must be based on the range of 0 to 100
            if (inputValue == 0) {
                volume = inputValue;
            } else if (inputValue> 30) {
                volume = 10 + ((inputValue - 30) * 9 / 7);
            } else {
                volume = Math.pow(inputValue + 15, 3) / 9112;
            }
            return volume;
        }
	}
}