﻿package op.extensions.phone
{
	import op.framework.*;
	//import op.extensions.phone.*;
	import op.extensions.phone.events.*;
	import op.external.*;
	
	public class EnterpriseLine extends Line 
	{
		private const LABEL_NEW_CALL:String 	= "New Call";
		private const LABEL_REDIAL:String 		= "Redial";
		private const LABEL_END_CALL:String 	= "End Call";
		private const LABEL_ANSWER:String 		= "Answer";
		private const LABEL_IGNORE:String 		= "Ignore";
		private const LABEL_HOLD:String 		= "Hold";
		private const LABEL_RESUME:String 		= "Resume";
		private const LABEL_TRANSFER:String 	= "Transfer";
		private const LABEL_BLIND:String 		= "Blind";
		private const LABEL_IM:String 			= "IM";
		private const LABEL_VIDEO:String 		= "Video";
		private const LABEL_CANCEL:String 		= "Cancel";
		private const LABEL_DELETE:String 		= "Delete";
		private const LABEL_MORE:String 		= "More";
		private const LABEL_MUTE:String			= "Mute";
		private const LABEL_JOIN_CALL:String	= "Join";
		
		public function EnterpriseLine(callControl:ICallControl, provider:String, account:Account, lineIndex:Number)
		{
			OPTrace.informational("EnterpriseLine::Constructor");
			super(callControl, provider, account, lineIndex);
			
			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_NEW_CALL, eventId:LineEvent.EVENT_NEW_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_REDIAL, eventId:LineEvent.EVENT_REDIAL});
		}
		
		/*
		 * displaySoftKeysState(XXXXXXXXX) functions define what soft keys should be present
		 * for the line in each state.  The default definition can be overriden by extending
		 * the Line class.  See EnterpriseLine.as or ResidentialLine.as
		 */
		protected override function displaySoftKeysStateOffHookEventOffHook(guiTerminal:Boolean) : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateOffHookEventOffHook entered");
			
			// GUI when off hook, change softkeys to display "End Call"
			m_currentButtonSet = new Array();
			if(guiTerminal)
				m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});
			else
				m_currentButtonSet.push({index:1, label:LABEL_JOIN_CALL, eventId:LineEvent.EVENT_JOIN});

			OPTrace.debug("Enterprise:displaySoftKeysStateOffHookEventOffHook exited");
		}
						
		protected override function displaySoftKeysStateOffHookEventOnHook() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateOffHookEventOnHook entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_NEW_CALL, eventId:LineEvent.EVENT_NEW_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_REDIAL, eventId:LineEvent.EVENT_REDIAL});

			OPTrace.debug("Enterprise:displaySoftKeysStateOffHookEventOnHook entered");
		}

		protected override function displaySoftKeysStateOffHookEventOnHookSpkPhone() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateOffHookEventOnHook entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_JOIN_CALL, eventId:LineEvent.EVENT_JOIN});

			OPTrace.debug("Enterprise:displaySoftKeysStateOffHookEventOnHook entered");
		}

		// Display "Answer" or "Ignore"
		protected override function displaySoftKeysStateOnHookIncomingCall() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateOnHookIncomingCall entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_ANSWER, eventId:LineEvent.EVENT_ANSWER});
			m_currentButtonSet.push({index:2, label:LABEL_IGNORE, eventId:LineEvent.EVENT_IGNORE});

			OPTrace.debug("Enterprise:displaySoftKeysStateOnHookIncomingCall entered");
		}

		protected override function displaySoftKeysStateIncomingCallEventHook() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateIncomingCallEventHook entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_HOLD, eventId:LineEvent.EVENT_HOLD});
			m_currentButtonSet.push({index:3, label:LABEL_TRANSFER, eventId:LineEvent.EVENT_ATRANSFER});
			m_currentButtonSet.push({index:4, label:LABEL_BLIND, eventId:LineEvent.EVENT_UTRANSFER});
			m_currentButtonSet.push({index:5, label:LABEL_IM, eventId:LineEvent.EVENT_IM});
			m_currentButtonSet.push({index:6, label:LABEL_MUTE, eventId:LineEvent.EVENT_MUTE});			

			OPTrace.debug("Enterprise:displaySoftKeysStateIncomingCallEventHook entered");
		}
	
		protected override function displaySoftKeysStateIncomingCallEventOffHookHandset() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateIncomingCallEventOffHookHandset entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_JOIN_CALL, eventId:LineEvent.EVENT_JOIN});

			OPTrace.debug("Enterprise:displaySoftKeysStateIncomingCallEventOffHookHandset entered");
		}
		
		protected override function displaySoftKeysStateIncomingCallEventDisconnected() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateIncomingCallEventDisconnected entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_NEW_CALL, eventId:LineEvent.EVENT_NEW_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_REDIAL, eventId:LineEvent.EVENT_REDIAL});

			OPTrace.debug("Enterprise:displaySoftKeysStateIncomingCallEventDisconnected entered");
		}
		
		protected override function displaySoftKeysStateProceedingEventConnected(transferInProgress:Boolean) : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateProceedingEventConnected entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_HOLD, eventId:LineEvent.EVENT_HOLD});
			if(!transferInProgress)
			{
				m_currentButtonSet.push({index:3, label:LABEL_TRANSFER, eventId:LineEvent.EVENT_ATRANSFER});
				m_currentButtonSet.push({index:4, label:LABEL_BLIND, eventId:LineEvent.EVENT_UTRANSFER});
				m_currentButtonSet.push({index:5, label:LABEL_IM, eventId:LineEvent.EVENT_IM});
				m_currentButtonSet.push({index:6, label:LABEL_MUTE, eventId:LineEvent.EVENT_MUTE});			
			}
			else
			{
				m_currentButtonSet.push({index:3, label:LABEL_TRANSFER, eventId:LineEvent.EVENT_TRANSFER});
				m_currentButtonSet.push({index:4, label:LABEL_IM, eventId:LineEvent.EVENT_IM});
				m_currentButtonSet.push({index:5, label:LABEL_MUTE, eventId:LineEvent.EVENT_MUTE});			
			}

			OPTrace.debug("Enterprise:displaySoftKeysStateProceedingEventConnected entered");
		}		
		
		protected override function displaySoftKeysStateRemoteAlertingEventConnected(transferInProgress:Boolean) : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateRemoteAlertingEventConnected entered");
			
			if(m_guiOffHook)
			{
				if(!transferInProgress)
				{
					m_currentButtonSet = new Array();
					m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});
					m_currentButtonSet.push({index:2, label:LABEL_HOLD, eventId:LineEvent.EVENT_HOLD});
					m_currentButtonSet.push({index:3, label:LABEL_TRANSFER, eventId:LineEvent.EVENT_ATRANSFER});
					m_currentButtonSet.push({index:4, label:LABEL_BLIND, eventId:LineEvent.EVENT_UTRANSFER});
					m_currentButtonSet.push({index:5, label:LABEL_IM, eventId:LineEvent.EVENT_IM});
					m_currentButtonSet.push({index:6, label:LABEL_MUTE, eventId:LineEvent.EVENT_MUTE});			
				}
				else
				{
					m_currentButtonSet = new Array();
					m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});
					m_currentButtonSet.push({index:2, label:LABEL_TRANSFER, eventId:LineEvent.EVENT_ATRANSFER_COMPLETE});
					m_currentButtonSet.push({index:3, label:LABEL_MUTE, eventId:LineEvent.EVENT_MUTE});			
				}
			}
			OPTrace.debug("Enterprise:displaySoftKeysStateRemoteAlertingEventConnected exited");
		}

		protected override function displaySoftKeysStateOffHookEventProceeding() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateOffHookEventProceeding entered");
		
			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});

			OPTrace.debug("Enterprise:displaySoftKeysStateOffHookEventProceeding exited");
		}
		
		protected override function displaySoftKeysStateProceedingEventRemoteAlerting() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateProceedingEventRemoteAlerting entered");
		
			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});

			OPTrace.debug("Enterprise:displaySoftKeysStateProceedingEventRemoteAlerting exited");
		}
		
		protected override function displaySoftKeysStateRemoteAlertingEventError() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateRemoteAlertingEventError entered");
				
			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});
		
			OPTrace.debug("Enterprise:displaySoftKeysStateRemoteAlertingEventError exited");
		}
		
		protected override function displaySoftKeysStateConnectedEventDisconnected() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateConnectedEventDisconnected entered");
				
			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_NEW_CALL, eventId:LineEvent.EVENT_NEW_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_REDIAL, eventId:LineEvent.EVENT_REDIAL});

			OPTrace.debug("Enterprise:displaySoftKeysStateConnectedEventDisconnected exited");
		}
		
		protected override function displaySoftKeysStateHoldEventOnHook() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateHoldEventOnHook entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_NEW_CALL, eventId:LineEvent.EVENT_NEW_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_REDIAL, eventId:LineEvent.EVENT_REDIAL});
				
			OPTrace.debug("Enterprise:displaySoftKeysStateHoldEventOnHook exited");
		}
		
		protected override function displaySoftKeysStateOnHookEventDigit() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateOnHookEventDigit entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_NEW_CALL, eventId:LineEvent.EVENT_NEW_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_DELETE, eventId:LineEvent.EVENT_BACKSPACE});
				
			OPTrace.debug("Enterprise:displaySoftKeysStateOnHookEventDigit exited");
		}
			
		protected override function displaySoftKeysStateOnHookEventNewCall() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateOnHookEventNewCall entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});
				
			OPTrace.debug("Enterprise:displaySoftKeysStateOnHookEventNewCall exited");
		}

		protected override function displaySoftKeysStateOnHookEventRedial() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateOnHookEventRedial entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});
				
			OPTrace.debug("Enterprise:displaySoftKeysStateOnHookEventRedial exited");
		}
		
		
		protected override function displaySoftKeysStateOnHookEventBackSpace(displayBackspace:Boolean) : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateOnHookEventBackSpace entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_NEW_CALL, eventId:LineEvent.EVENT_NEW_CALL});
			if(displayBackspace)
				m_currentButtonSet.push({index:2, label:LABEL_DELETE, eventId:LineEvent.EVENT_BACKSPACE});
			else 				
				m_currentButtonSet.push({index:2, label:LABEL_REDIAL, eventId:LineEvent.EVENT_REDIAL});
			OPTrace.debug("Enterprise:displaySoftKeysStateOnHookEventBackSpace exited");
		}

		protected override function displaySoftKeysStateOffHookEventEndCall() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateOffHookEventEndCall entered");
			
			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_NEW_CALL, eventId:LineEvent.EVENT_NEW_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_REDIAL, eventId:LineEvent.EVENT_REDIAL});

			OPTrace.debug("Enterprise:displaySoftKeysStateOffHookEventEndCall exited");
		}

		protected override function displaySoftKeysStateOffHookEventEndCallJoin() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateOffHookEventEndCallJoin entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_JOIN_CALL, eventId:LineEvent.EVENT_JOIN});

			OPTrace.debug("Enterprise:displaySoftKeysStateOffHookEventEndCallJoin entered");
		}

		protected override function displaySoftKeysStateProceedingEventEndCallJoin() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateProceedingEventEndCallJoin entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_JOIN_CALL, eventId:LineEvent.EVENT_JOIN});

			OPTrace.debug("Enterprise:displaySoftKeysStateProceedingEventEndCallJoin entered");
		}

		protected override function displaySoftKeysStateProceedingEventJoin() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateProceedingEventJoin entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});

			OPTrace.debug("Enterprise:displaySoftKeysStateProceedingEventJoin entered");
		}
		
		protected override function displaySoftKeysStateRemoteAlertingEventEndCallJoin() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateRemoteAlertingEventEndCallJoin entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_JOIN_CALL, eventId:LineEvent.EVENT_JOIN});

			OPTrace.debug("Enterprise:displaySoftKeysStateRemoteAlertingEventEndCallJoin entered");
		}

		protected override function displaySoftKeysStateRemoteAlertingEventJoin() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateRemoteAlertingEventJoin entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});

			OPTrace.debug("Enterprise:displaySoftKeysStateRemoteAlertingEventJoin entered");
		}


		protected override function displaySoftKeysStateOffHookEventJoin() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateOffHookEventJoin entered");
			
			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});

			OPTrace.debug("Enterprise:displaySoftKeysStateOffHookEventJoin exited");
		}
		
		protected override function displaySoftKeysStateIncomingCallEventAnswer() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateIncomingCallEventAnswer entered");
			
			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_HOLD, eventId:LineEvent.EVENT_HOLD});
			m_currentButtonSet.push({index:3, label:LABEL_TRANSFER, eventId:LineEvent.EVENT_ATRANSFER});
			m_currentButtonSet.push({index:4, label:LABEL_BLIND, eventId:LineEvent.EVENT_UTRANSFER});
			m_currentButtonSet.push({index:5, label:LABEL_IM, eventId:LineEvent.EVENT_IM});
			m_currentButtonSet.push({index:6, label:LABEL_MUTE, eventId:LineEvent.EVENT_MUTE});			

			OPTrace.debug("Enterprise:displaySoftKeysStateIncomingCallEventAnswer exited");
		}
		
		protected override function displaySoftKeysStateIncomingCallEventIgnore() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateIncomingCallEventIgnore entered");
			
			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_NEW_CALL, eventId:LineEvent.EVENT_NEW_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_REDIAL, eventId:LineEvent.EVENT_REDIAL});
			

			OPTrace.debug("Enterprise:displaySoftKeysStateIncomingCallEventIgnore exited");
		}
		
		protected override function displaySoftKeysStateProceedingEventEndCall() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateProceedingEventEndCall entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_NEW_CALL, eventId:LineEvent.EVENT_NEW_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_REDIAL, eventId:LineEvent.EVENT_REDIAL});

			OPTrace.debug("Enterprise:displaySoftKeysStateProceedingEventEndCall exited");
		}
		
		protected override function displaySoftKeysStateRemoteAlertingEventEndCall() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateRemoteAlertingEventEndCall entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_NEW_CALL, eventId:LineEvent.EVENT_NEW_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_REDIAL, eventId:LineEvent.EVENT_REDIAL});

			OPTrace.debug("Enterprise:displaySoftKeysStateRemoteAlertingEventEndCall exited");
		}
				
		protected override function displaySoftKeysStateConnectedEventEndCall() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateConnectedEventEndCall entered");
					
			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_NEW_CALL, eventId:LineEvent.EVENT_NEW_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_REDIAL, eventId:LineEvent.EVENT_REDIAL});

			OPTrace.debug("Enterprise:displaySoftKeysStateConnectedEventEndCall exited");
		}
	
		protected override function displaySoftKeysStateConnectedEventJoin() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateConnectedEventJoin entered");
					
			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_HOLD, eventId:LineEvent.EVENT_HOLD});
			m_currentButtonSet.push({index:3, label:LABEL_TRANSFER, eventId:LineEvent.EVENT_ATRANSFER});
			m_currentButtonSet.push({index:4, label:LABEL_BLIND, eventId:LineEvent.EVENT_UTRANSFER});
			m_currentButtonSet.push({index:5, label:LABEL_IM, eventId:LineEvent.EVENT_IM});
			m_currentButtonSet.push({index:6, label:LABEL_MUTE, eventId:LineEvent.EVENT_MUTE});			

			OPTrace.debug("Enterprise:displaySoftKeysStateConnectedEventJoin exited");
		}
		
		protected override function displaySoftKeysStateConnectedEventHold() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateConnectedEventHold entered");
		
			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_RESUME, eventId:LineEvent.EVENT_RESUME});
			m_currentButtonSet.push({index:2, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});

			OPTrace.debug("Enterprise:displaySoftKeysStateConnectedEventHold exited");
		}
		
		protected override function displaySoftKeysStateConnectedEventAttendedTransfer() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateConnectedEventAttendedTransfer entered");
			
			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_TRANSFER, eventId:LineEvent.EVENT_ATRANSFER_COMPLETE});
			m_currentButtonSet.push({index:2, label:LABEL_CANCEL, eventId:LineEvent.EVENT_CANCEL});

			OPTrace.debug("Enterprise:displaySoftKeysStateConnectedEventAttendedTransfer exited");
		}

		protected override function displaySoftKeysStateConnectedEventUnattendedTransfer() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateConnectedEventUnattendedTransfer entered");
			
			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_TRANSFER, eventId:LineEvent.EVENT_UTRANSFER_COMPLETE});
			m_currentButtonSet.push({index:2, label:LABEL_CANCEL, eventId:LineEvent.EVENT_CANCEL});

			OPTrace.debug("Enterprise:displaySoftKeysStateConnectedEventUnattendedTransfer exited");
		}
		
		protected override function displaySoftKeysStateHoldEventEndCall() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateHoldEventEndCall entered");
			
			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_NEW_CALL, eventId:LineEvent.EVENT_NEW_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_REDIAL, eventId:LineEvent.EVENT_REDIAL});
		
			OPTrace.debug("Enterprise:displaySoftKeysStateHoldEventEndCall exited");
		}
		
		protected override function displaySoftKeysStateHoldEventResume() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateHoldEventResume entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_HOLD, eventId:LineEvent.EVENT_HOLD});
			m_currentButtonSet.push({index:3, label:LABEL_TRANSFER, eventId:LineEvent.EVENT_ATRANSFER});
			m_currentButtonSet.push({index:4, label:LABEL_BLIND, eventId:LineEvent.EVENT_UTRANSFER});
			m_currentButtonSet.push({index:5, label:LABEL_IM, eventId:LineEvent.EVENT_IM});
			//m_currentButtonSet.push({index:6, label:LABEL_VIDEO, eventId:LineEvent.EVENT_VIDEO});
			m_currentButtonSet.push({index:6, label:LABEL_MUTE, eventId:LineEvent.EVENT_MUTE});
		
			OPTrace.debug("Enterprise:displaySoftKeysStateHoldEventResume exited");
		}

		protected override function displaySoftKeysStateAttendedTransferEventAttendedTransfer() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateAttendedTransferEventAttendedTransfer entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_NEW_CALL, eventId:LineEvent.EVENT_NEW_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_REDIAL, eventId:LineEvent.EVENT_REDIAL});

			OPTrace.debug("Enterprise:displaySoftKeysStateAttendedTransferEventAttendedTransfer exited");
		}
		
		protected override function displaySoftKeysStateAttendedTransferEventCancel() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateAttendedTransferEventCancel entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_HOLD, eventId:LineEvent.EVENT_HOLD});
			m_currentButtonSet.push({index:3, label:LABEL_TRANSFER, eventId:LineEvent.EVENT_ATRANSFER});
			m_currentButtonSet.push({index:4, label:LABEL_BLIND, eventId:LineEvent.EVENT_UTRANSFER});
			m_currentButtonSet.push({index:5, label:LABEL_IM, eventId:LineEvent.EVENT_IM});
			//m_currentButtonSet.push({index:6, label:LABEL_VIDEO, eventId:LineEvent.EVENT_VIDEO});
			m_currentButtonSet.push({index:6, label:LABEL_MUTE, eventId:LineEvent.EVENT_MUTE});

			OPTrace.debug("Enterprise:displaySoftKeysStateAttendedTransferEventCancel exited");
		}
		
		protected override function displaySoftKeysStateUnAttendedTransferEventTransferComplete() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateUnAttendedTransferEventTransferComplete entered");
			
			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_NEW_CALL, eventId:LineEvent.EVENT_NEW_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_REDIAL, eventId:LineEvent.EVENT_REDIAL});
		
			OPTrace.debug("Enterprise:displaySoftKeysStateUnAttendedTransferEventTransferComplete exited");
		}
		
		protected override function displaySoftKeysStateUnAttendedTransferEventCancel() : void
		{
			OPTrace.debug("Enterprise:displaySoftKeysStateUnAttendedTransferEventCancel entered");

			m_currentButtonSet = new Array();
			m_currentButtonSet.push({index:1, label:LABEL_END_CALL, eventId:LineEvent.EVENT_END_CALL});
			m_currentButtonSet.push({index:2, label:LABEL_HOLD, eventId:LineEvent.EVENT_HOLD});
			m_currentButtonSet.push({index:3, label:LABEL_TRANSFER, eventId:LineEvent.EVENT_ATRANSFER});
			m_currentButtonSet.push({index:4, label:LABEL_BLIND, eventId:LineEvent.EVENT_UTRANSFER});
			m_currentButtonSet.push({index:5, label:LABEL_IM, eventId:LineEvent.EVENT_IM});
			//m_currentButtonSet.push({index:6, label:LABEL_VIDEO, eventId:LineEvent.EVENT_VIDEO});
			m_currentButtonSet.push({index:6, label:LABEL_MUTE, eventId:LineEvent.EVENT_MUTE});

			OPTrace.debug("Enterprise:displaySoftKeysStateUnAttendedTransferEventCancel exited");
		}
			
	}
}