﻿package op.extensions.phone
{
	import op.external.OPTrace;
	import op.framework.OPLang;
	
    public class IntercomLine extends Line
	{
		private var m_inBaseIntercom:Boolean = false;
		private var m_inHSIntercom:Array = null;
		private var m_inBaseIntercomAlert:Boolean = true;
		private var m_targetName:String 				= new String("");
		private var m_targetNumber:String 				= new String("");
		private var m_lineList:* = null;
		private var m_callControl:*;
		
		public function IntercomLine(callControl:*, provider:String = "", account:Account = null, lineIndex:Number = 1)
		{
			OPTrace.informational("IntercomLine::Constructor");
			m_callControl = callControl;
			super(callControl, provider, account, lineIndex);
			setButtonsOnHook();
		}
		
		public function get inBaseIntercom():Boolean { return m_inBaseIntercom; }		
		public function set inBaseIntercom(inter:Boolean) { m_inBaseIntercom = inter; }
		public function get inBaseIntercomAlert():Boolean { return m_inBaseIntercomAlert; }		
		public function set inBaseIntercomAlert(inter:Boolean) { m_inBaseIntercomAlert = inter; }
		public function get inHSIntercom():Array { return m_inHSIntercom; }		
		public function set inHSIntercom(inter:Array) { m_inHSIntercom = inter; }
		public function set lineList(l:*) { m_lineList = l; }
		public function get lineList():* { return m_lineList; }
		
		public function setButtonsOnHook()
		{
			if ( !m_inBaseIntercom ) {
				m_currentButtonSet = new Array();
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_NEW_CALL, enabled:false } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_REDIAL, enabled:false } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_END_CALL, enabled:false } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_MUTE, enabled:false } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_HOOK_FLASH, enabled:false } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_BACKSPACE, enabled:false } );
				//m_currentButtonSet.push( { eventId:LineEvent.EVENT_INTERCOM, enabled:true } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_INTERCOM, enabled:false } );
			}
		}
		
		public function setButtonsOffHook()
		{
			m_currentButtonSet = new Array();
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_NEW_CALL, enabled:false } );
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_REDIAL, enabled:false } );
			//m_currentButtonSet.push( { eventId:LineEvent.EVENT_INTERCOM_DISCONNECT, enabled:true } );
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_INTERCOM_DISCONNECT, enabled:false } );
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_MUTE, enabled:true } );
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_HOOK_FLASH, enabled:false } );
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_BACKSPACE, enabled:false } );
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_INTERCOM, enabled:false } );
		}

    }
}    

