﻿package op.extensions.phone
{
	
	import flash.events.EventDispatcher;
	import flash.system.fscommand;
	import flash.events.TimerEvent;
	import flash.utils.Timer;

	import op.framework.*;
	//import op.extensions.phone.*;
	import op.extensions.phone.events.*;
	import op.external.*;

	public class Line extends EventDispatcher 
	{	
		// These two properties are requred by framework. 
		public var label:String = null;
		public var icon:Object = null;
		
		private static var m_muted:Boolean = false;

		public static const STATE_ON_HOOK:Number 				= 1;
		public static const STATE_OFF_HOOK:Number 				= 2;
		public static const STATE_INCOMING_CALL:Number 			= 3;
		public static const STATE_PROCEEDING:Number 			= 4;
		public static const STATE_REMOTE_ALERTING:Number 		= 5;
		public static const STATE_CONNECTED:Number 				= 6;
		public static const STATE_DISCONNECTED:Number			= 7;
		public static const STATE_HOLD:Number 					= 8;
		public static const STATE_ATTENDED_TRANSFER:Number 		= 9;
		public static const STATE_UNATTENDED_TRANSFER:Number	= 10;
		
		protected var m_guiOffHook:Boolean = false;
		protected var m_currentButtonSet:Array = null;

		protected var m_prevGUIOH:Boolean = false;
		private var m_offHookCounter:Number = 0;
		private var m_prevOffHookCnt:Number = 0;

		private var timer:Timer;
		private var duration:Number = 0;
		
		private var m_callControlLine:CallControlLine 	= null;
		private var m_errorString:String				= new String("");
		private var m_targetName:String 				= new String("");
		private var m_targetNumber:String 				= new String("");
		private var m_targetExtraDigits:String			= new String("");
		private var m_transferToNumber:String			= new String("");
		private var m_currentState:Number 				= STATE_ON_HOOK;
		private var m_instantMessage:String 			= new String("");
		private var m_inTransfer:Boolean				= false;
		protected var m_lastNumberDialed:String			= new String("");
		private var m_callControl:*						= null;
		private var m_contactDB:*;
		private var m_incoming:Boolean 					= false;
		private var ringtone:Boolean 					= false;
		
		public function Line(callControl:*, provider:String, account:Account, lineIndex:Number)
		{
			OPTrace.informational("Line::Constructor");
			super();

			//set timer event for duration
			timer = new Timer(1000, 0 );
			timer.addEventListener(TimerEvent.TIMER, incDuration, false, 0, true);
			
			try{
				m_callControl = callControl;
				
				//if( provider && account && lineIndex >= 0 ) //intercom_line does not meet this criteria
					m_callControlLine = new CallControlLine(provider, account, lineIndex);
			}
			catch(e:Error) { OPTrace.debug("Failed to initialize.");	}
				
			try 
			{
				//create new contactDB
				var ContactDB:Class = OPLink.classDefinition("ContactDB", "ContactDBInterface") as Class ;
				var contactlib = new ContactDB();
				m_contactDB = contactlib.instance;
			}
			catch(e:Error) { OPTrace.informational("Failed to load ContactDB");	}

		}
		
		public function getButtonArray() : Array { return m_currentButtonSet; }
		public function getCallControlLine() : * { return m_callControlLine; }
		public function getProvider() { return m_callControlLine.getProvider(); }
		public function getAccount() { return m_callControlLine.getAccount(); }
		public function setLineIndex(lineIndex:Number) { m_callControlLine.setLineIndex(lineIndex); }
		public function getLineIndex() : Number	{ return m_callControlLine.getLineIndex(); }
		public function setError(error:String) { m_errorString = error; }
		public function getError() { return m_errorString;	}
		public function set offHookCounter(offHookCnt:Number) { m_offHookCounter = offHookCnt; }
		public function get offHookCounter():Number { return m_offHookCounter; }
		public function set guiOffHook(guiOffHook:Boolean) { m_guiOffHook = guiOffHook; }
		public function get guiOffHook():Boolean { return m_guiOffHook; }
		public function set prevGUIOffHook(prevGOH:Boolean) { m_prevGUIOH = prevGOH;  }
		public function get prevGUIOffHook():Boolean { return m_prevGUIOH;  }
		public function set prevOffHookCnt(prevOHC:Number) { m_prevOffHookCnt = prevOHC; }
		public function get prevOffHookCnt():Number { return m_prevOffHookCnt; }
		public function getMuteState() : Boolean { return m_muted; }
		public function getState() : Number	{ return m_currentState; }
		public function setTargetName(tName:String)	{ m_targetName = tName;	}
		public function getTargetName() : String { return m_targetName; }
		public function setTargetNumber(tNumber:String)	{ m_targetNumber = tNumber;	}
		public function getTargetNumber() : String { return m_targetNumber; }
		public function getTargetExtraDigits() : String { return m_targetExtraDigits; }
		public function stopDuration() { timer.stop();	}
		public function incDuration(e:* = null):void { duration++; }
		public function get isIncoming() : Boolean { return m_incoming; }
		
		public function toggleMute()
		{
			OPTrace.debug("toggleMute " + m_muted);
			m_muted = !m_muted;
			m_callControl.mute( m_muted ? "1" : "0");
		}
		
		public function startDuration()
		{
			duration = 0;
			timer.start();
		}
		
		public function reset()
		{
			m_offHookCounter = 0;
			displaySoftKeysStateOffHookEventEndCall();
			onSoftKeyEvent(new LineEvent(LineEvent.EVENT_END_CALL));
		}

		public function formatDuration():String
		{
			var hour, min, sec;
			var remainder:int = duration / 3600;
			
			remainder > 9 ? hour = remainder : hour = "0" + remainder;
			remainder = (duration - hour * 3600) / 60;
			remainder > 9 ? min = remainder : min = "0" + remainder;
			remainder = duration - (hour * 3600) - (min * 60);
			remainder > 9 ? sec = remainder : sec = "0" + remainder;
			
			return hour + ":" + min + ":" + sec;
		}
		
		public function incOffHook() {
			m_prevOffHookCnt = 0;
			m_offHookCounter++;
			m_guiOffHook = true;
		}
		
		public function decOffHook() {
			m_guiOffHook = false;
			if (m_offHookCounter > 0) {
				m_prevOffHookCnt = 0;
				m_offHookCounter--;
			}
		}

		public function stopRinging() {

			m_callControlLine.account.stopRingback();

		}

		public function loadContacts (ring:Boolean = false) {
			ringtone = ring; //load ringtones?
			m_contactDB.addEventListener("LOADED", onContactsDBLoaded);
			m_contactDB.load();
		}
			
		private function onContactsDBLoaded(event:*)
		{
			OPTrace.informational("Line::onContactsDBLoaded!");
			m_contactDB.removeEventListener("LOADED", onContactsDBLoaded);
			
			// Give the account a way to check the status of the line.
			// this is used to ensure the ringer wont start on a connected
			// call. --KLee 4/8/2011
			Account(m_callControl.accountArray[0]).getState = this.getState;
							
			//similiar logic found in OPEXCallLog.as for matching contacts in call records
			for each (var contact:XML in event.getXMLData()..c) 
			{
				if( getTargetNumber() ) {
					if ( contact.@work == getTargetNumber() || 
					     contact.@mobile == getTargetNumber() ||
						 contact.@home == getTargetNumber() ||
						 contact.@other == getTargetNumber() ) {

						setTargetName(contact.@fname + " " + contact.@lname);
						
						if ( ringtone ) {
							OPTrace.debug("1: " + contact.@ringtone);
							m_callControl.accountArray[0].loadRingtones(contact.@ringtone);
						}
						return;
					}
					else if(getTargetName()=="")
						setTargetName(getTargetNumber());
				}
				else {
					setTargetName("");
					break;
				}
			}
			if ( ringtone )
				m_callControl.accountArray[0].loadRingtones();
			ringtone = false;
		}
		
		/*
		 * displaySoftKeysState(XXXXXXXXX) functions define what soft keys should be present
		 * for the line in each state.  The default definition can be overriden by extending
		 * the Line class.  See EnterpriseLine.as or ResidentialLine.as
		 */
		protected function displaySoftKeysStateOffHookEventOffHook(guiTerminal:Boolean) : void {}
		protected function displaySoftKeysStateOffHookEventOnHook() : void {}
		protected function displaySoftKeysStateOffHookEventOnHookSpkPhone() : void {}
		protected function displaySoftKeysStateOnHookIncomingCall() : void {}
		protected function displaySoftKeysStateIncomingCallEventHook() : void {}
		protected function displaySoftKeysStateIncomingCallEventOffHookHandset() : void {}
		protected function displaySoftKeysStateIncomingCallEventDisconnected() : void { }
		protected function displaySoftKeysStateIncomingCallEventConnected() : void { }
		protected function displaySoftKeysStateProceedingEventConnected(transferInProgress:Boolean) : void {}
		protected function displaySoftKeysStateRemoteAlertingEventConnected(transferInProgress:Boolean) : void {}
		protected function displaySoftKeysStateOffHookEventProceeding() : void {}
		protected function displaySoftKeysStateProceedingEventRemoteAlerting() : void {}
		protected function displaySoftKeysStateRemoteAlertingEventError() : void {}
		protected function displaySoftKeysStateConnectedEventDisconnected() : void {}
		protected function displaySoftKeysStateHoldEventOnHook() : void {}
		protected function displaySoftKeysStateOnHookEventDigit() : void {}
		protected function displaySoftKeysStateOnHookEventNewCall() : void {}
		protected function displaySoftKeysStateOnHookEventRedial() : void {}
		protected function displaySoftKeysStateOnHookEventBackSpace(displayBackspace:Boolean) : void {}
		protected function displaySoftKeysStateOffHookEventEndCall() : void {}
		protected function displaySoftKeysStateOffHookEventEndCallJoin() : void {}
		protected function displaySoftKeysStateOffHookEventJoin() : void {}
		protected function displaySoftKeysStateIncomingCallEventAnswer() : void {}
		protected function displaySoftKeysStateIncomingCallEventIgnore() : void {}
		protected function displaySoftKeysStateProceedingEventEndCall() : void {}
		protected function displaySoftKeysStateRemoteAlertingEventEndCall() : void {}
		protected function displaySoftKeysStateConnectedEventEndCall() : void {}
		protected function displaySoftKeysStateConnectedEventJoin() : void {}
		protected function displaySoftKeysStateConnectedEventHold() : void {}
		protected function displaySoftKeysStateConnectedEventAttendedTransfer() : void {}
		protected function displaySoftKeysStateConnectedEventUnattendedTransfer() : void {}
		protected function displaySoftKeysStateHoldEventEndCall() : void {}
		protected function displaySoftKeysStateHoldEventResume() : void {}
		protected function displaySoftKeysStateAttendedTransferEventAttendedTransfer() : void {}
		protected function displaySoftKeysStateAttendedTransferEventCancel() : void {}
		protected function displaySoftKeysStateUnAttendedTransferEventTransferComplete() : void {}		
		protected function displaySoftKeysStateUnAttendedTransferEventCancel() : void { }
		protected function displaySoftKeysStateRemoteAlertingEventJoin() : void { }
		protected function displaySoftKeysStateProceedingEventJoin() : void { }
		protected function displaySoftKeysStateProceedingEventEndCallJoin() : void { }
		protected function displaySoftKeysStateRemoteAlertingEventEndCallJoin() : void { }
		protected function setInBaseIntercom(baseInIntercom:Boolean) : void { }
		protected function getInBaseIntercom() : Boolean { return false; }

		private function stateOnHookEventHook(event:*) : Number
		{
			var nextState:Number = STATE_ON_HOOK;
			
			if(!event.isOnHook())
			{
				// Line is off hook.				
				displaySoftKeysStateOffHookEventOffHook(!event.fromDectHandset());
				nextState = Line.STATE_OFF_HOOK;
			}
			
			return nextState;
		}
		
		private function stateOffHookEventHook(event:*) : Number
		{
			var nextState:Number = Line.STATE_OFF_HOOK;

			if(event.isOnHook())
			{
				if(m_offHookCounter == 0)
				{
					displaySoftKeysStateOffHookEventOnHook();
					nextState = Line.STATE_ON_HOOK;
				}
				else if(event.fromGUI())
				{
					displaySoftKeysStateOffHookEventOnHookSpkPhone();
				}
			}
			
			return nextState;
		}
		
		private function stateOnHookEventIncomingCall(event:*) : Number
		{
			var nextState:Number = STATE_ON_HOOK;
			
			displaySoftKeysStateOnHookIncomingCall();
			nextState =  Line.STATE_INCOMING_CALL;
			return nextState;
		}
		
		private function stateOnHookEventDectCallerID(event:*) : Number
		{
			var nextState:Number = STATE_ON_HOOK;
			displaySoftKeysStateOnHookIncomingCall();
			nextState =  Line.STATE_INCOMING_CALL;
	
			return nextState;
		}
		
		private function stateIncomingCallEventHook(event:*) : Number
		{
			var nextState:Number = Line.STATE_INCOMING_CALL;

			if(!event.isOnHook())
			{									
				if(event.fromGUI())
					displaySoftKeysStateIncomingCallEventHook();
				else
					displaySoftKeysStateIncomingCallEventOffHookHandset();

				m_callControlLine.account.stopRingback();

				nextState = Line.STATE_CONNECTED;
			}
			
			return nextState;
		}
		
		private function stateIncomingCallEventDisconnected(event:*) : Number
		{
			var nextState:Number = STATE_ON_HOOK;
			
			m_callControlLine.account.stopRingback();

			displaySoftKeysStateIncomingCallEventDisconnected();
		
			return nextState;
		}
		
		private function stateProceedingEventConnected(event:*) : Number
		{
			var nextState:Number = Line.STATE_CONNECTED;
			
			displaySoftKeysStateProceedingEventConnected(m_inTransfer);
			
			return nextState;
		}

		/*
		 * Received a network event
		 */
		public function updateState(event:*)
		{
			OPTrace.debug("Line" + getLineIndex() + "::updateState::currState::" + m_currentState + "::event received::m_offHookCounter(before):" + m_offHookCounter);
			
			var nextState:Number = 0;
			
			if (event is ConnectedEvent)
			{
				startDuration();
			}
			else if(event is DisconnectedEvent && m_currentState != Line.STATE_ON_HOOK && !getInBaseIntercom())
			{
				m_offHookCounter = 0;
				setTargetName("");
				setTargetNumber("");
				stopDuration();
				m_guiOffHook = false;
				m_incoming = false;
			}
			else if(event is HookEvent)
			{
				if(event.isOnHook())
				{
					if (m_offHookCounter > 0) {
						m_prevOffHookCnt = 0;
						m_offHookCounter--;
					}
				}
				else 
				{
					if (!m_callControl.isFrameClient) {
						m_prevOffHookCnt = 0;
						m_offHookCounter++;
					}
					else
						incOffHook();
				}
			}
			else if( event is ProceedingEvent && m_callControl.launchc2d && !m_callControl.isFrameClient )
			{
				incOffHook();
			}
			else if ( event is CallControlErrorEvent && m_callControl.launchc2d )
			{
				incOffHook();
				nextState = STATE_OFF_HOOK;
				displaySoftKeysStateOffHookEventOffHook(true);
			}
			
			OPTrace.debug("Line" + getLineIndex() + "::updateState::m_offHookCounter(after):" + m_offHookCounter);
			
			switch(m_currentState)
			{
			case STATE_ON_HOOK:
			{
				if(event is HookEvent)
				{
					nextState = stateOnHookEventHook(event);
				}
				else if(event is IncomingCallEvent)
				{
					nextState = stateOnHookEventIncomingCall(event);
					m_incoming = true;
				}
				else if ( event is DectCallerIDEvent )
				{
					nextState = stateOnHookEventDectCallerID(event);
				}
				else if(event is ConnectedEvent)
				{
					nextState = STATE_CONNECTED;
				}
				//Click2Dial from 3rd party application.
				else if(event is ProceedingEvent)
				{
					if (!m_callControl.isFrameClient)
						setTargetNumber(event.getDialedNumber());
					nextState = Line.STATE_PROCEEDING;
	
					// Display "End Call"
					displaySoftKeysStateOffHookEventProceeding();
					loadContacts();
				}
				else if( event is HookFlashEvent )
				{
					nextState = STATE_OFF_HOOK;
					if (m_offHookCounter == 0) {
						m_prevOffHookCnt = 0;
						m_offHookCounter++;
					}
				}
				else if(event is DialPlanErrorEvent && m_callControl.launchc2d)
				{
					incOffHook();
					nextState = STATE_OFF_HOOK;
					displaySoftKeysStateOffHookEventOffHook(true);
				}
			}
			break;
			case STATE_OFF_HOOK:
			{
				if(event is HookEvent)
				{
					nextState = stateOffHookEventHook(event);
				}
				else if(event is ProceedingEvent)
				{
					//proceedingEvent = ProceedingEvent(event);

					if (!m_callControl.isFrameClient)
						setTargetNumber(event.getDialedNumber());
					nextState = Line.STATE_PROCEEDING;
	
					if(m_guiOffHook)
						displaySoftKeysStateOffHookEventProceeding();
				}
				else if(event is HookFlashEvent )
				{
					nextState = STATE_ON_HOOK;
					if (m_offHookCounter > 0) {
						m_prevOffHookCnt = 0;
						m_offHookCounter--;
					}
				}
				else if(event is DisconnectedEvent)
				{
					nextState = STATE_ON_HOOK;

					displaySoftKeysStateOffHookEventOnHook();
				}
			}
			break;
			case STATE_INCOMING_CALL:
			{
				if(event is HookEvent)
				{
					nextState = stateIncomingCallEventHook(event);
				}
				else if (event is DisconnectedEvent )
				{
					nextState = stateIncomingCallEventDisconnected(event);
				}
				else if (event is IgnoreCallEvent)
				{
					nextState = stateIncomingCallEventDisconnected(event);
				}
				else if(event is ConnectedEvent)
				{
					m_callControlLine.account.stopRingback();
					nextState = STATE_CONNECTED;
				}
			}
			break;
			case STATE_PROCEEDING:
			{
				if(event is RemoteAlertingEvent)
				{
					OPTrace.debug("STATE_PROCEEDING : Transitioning to STATE_REMOTE_ALERTING");

					if(m_guiOffHook)
						displaySoftKeysStateProceedingEventRemoteAlerting();

					nextState = Line.STATE_REMOTE_ALERTING;
				}
				else if(event is ConnectedEvent)
				{
					nextState = stateProceedingEventConnected(event);
				}
				else if(event is CallControlErrorEvent)
				{
					//var errorEvent:CallControlErrorEvent = CallControlErrorEvent(event);
					setError(event.getErrorMessage());
					
					if(m_guiOffHook)
						displaySoftKeysStateRemoteAlertingEventError();
				}
				else if(event is HookEvent) // Handset
				{
					//hookEvent = HookEvent(event);
					if(event.isOnHook())
					{									
						if(m_offHookCounter == 0)
						{
							displaySoftKeysStateProceedingEventEndCall();
							
							nextState = STATE_ON_HOOK;
						}
					}
				}
				
			}
			break;
			case STATE_REMOTE_ALERTING:
			{
				if(event is ConnectedEvent)
				{
					OPTrace.debug("STATE_REMOTE_ALERTING : Transitioning to STATE_CONNECTED");
					if(m_guiOffHook)
						displaySoftKeysStateRemoteAlertingEventConnected(m_inTransfer);
						
					nextState = Line.STATE_CONNECTED;
				}
				else if(event is CallControlErrorEvent)
				{
					setError(event.getErrorMessage());
					
					if(m_guiOffHook)
						displaySoftKeysStateRemoteAlertingEventError();
				}
				else if(event is HookEvent) // Handset
				{
					if(event.isOnHook())
					{									
						if(m_offHookCounter == 0)
						{
							displaySoftKeysStateRemoteAlertingEventEndCall();
							
							nextState = STATE_ON_HOOK;
						}
					}
				}
			}
			break;
			case STATE_CONNECTED:
			{
				if(event is DisconnectedEvent && !getInBaseIntercom())
				{
					nextState = STATE_ON_HOOK;
					
					displaySoftKeysStateConnectedEventDisconnected();
				}
				else if(event is MessageEvent)
				{
					//var messageEvent:MessageEvent = MessageEvent(event);
					m_instantMessage += event.getMessage();
				}
				else if(event is HookFlashEvent )
				{
					nextState = STATE_HOLD;
				}
				else if(event is CallControlErrorEvent )
				{
					if (event.getErrorMessage() == "Not Implemented")
						nextState = STATE_HOLD;
				}
			}
			break;
			case STATE_HOLD:
			{
				if(event is DisconnectedEvent)
				{
					nextState = STATE_ON_HOOK;
					
					displaySoftKeysStateHoldEventOnHook();
				}
				else if(event is HookFlashEvent )
				{
					nextState = STATE_CONNECTED;
				}

			}
			break;
			case STATE_ATTENDED_TRANSFER:
			{
				if(event is DisconnectedEvent)
				{
					nextState = STATE_ON_HOOK;
					
					displaySoftKeysStateConnectedEventDisconnected();
				}
			}
			break;
			case STATE_UNATTENDED_TRANSFER:
			{
				if(event is DisconnectedEvent)
				{
					nextState = STATE_ON_HOOK;
					
					displaySoftKeysStateConnectedEventDisconnected();
				}
			}
			break;
			}
			
			if(nextState)
			{
				onSoftKeyEvent(new LineEvent(LineEvent.EVENT_EXIT_STATE));
				m_currentState = nextState;
				onSoftKeyEvent(new LineEvent(LineEvent.EVENT_ENTER_STATE));
			}

			if (m_callControl.isFrameClient && event is HookEvent && event.isOnHook()) { //Get the last dialed string when on hook
				m_lastNumberDialed = m_callControl.getLastNumber();
				displaySoftKeysStateOffHookEventOnHook();
			}
			if (!m_callControl.isFrameClient && event is ProceedingEvent) { // after target number has been set by proceeding event
				m_lastNumberDialed = getTargetNumber();
			}
			//else if ( event is ReminderEvent || event is DectCallerIDEvent ) {
				//m_callControlLine.account.startRingback();
			//}
			
			dispatchEvent(new LineEvent(LineEvent.EVENT_INVALIDATE_OBJECT));
		}

		public function onSoftKeyEvent(event:*)
		{
			var nextState:Number = 0;

			OPTrace.debug("Line" + getLineIndex() + ".onSoftKeyEvent::currState::" + m_currentState + ", eventId = " + event.m_eventId + "::m_offHookCounter(before):" + m_offHookCounter);
			
			switch(m_currentState)
			{
			case STATE_ON_HOOK:
			{
				OPTrace.debug("STATE_ON_HOOK");
				
				switch(event.m_eventId)
				{
				case LineEvent.EVENT_ENTER_STATE:
				{
					if (!getInBaseIntercom()) {
						OPTrace.debug("STATE_ON_HOOK : EVENT_ENTER_STATE");
						setTargetName("");
						m_targetNumber = "";
						m_targetExtraDigits = "";
						m_errorString = "";
						m_transferToNumber = "";
						m_inTransfer = false;
					}
				}
				break;
				case LineEvent.EVENT_DIGIT:
				{
					//var digitEvent:DigitLineEvent = new DigitLineEvent(event.m_digit);
					m_targetNumber = m_targetNumber.concat(event.m_digit);
					OPTrace.debug("Pressed Digit " +  event.m_digit);
					setTargetName("");
					
					displaySoftKeysStateOnHookEventDigit();
					loadContacts();
				}
				break;
				case LineEvent.EVENT_NEW_CALL:
				{
					OPTrace.debug("EVENT_NEW_CALL");
					
					if(getTargetNumber().length)
					{
						OPTrace.debug("Dial " + getTargetNumber());

						displaySoftKeysStateOnHookEventNewCall();
						
						m_callControl.dial(getCallControlLine(), getTargetNumber());
						
						nextState = STATE_OFF_HOOK;
					}
					else {
						m_callControl.offhook(getCallControlLine());

						displaySoftKeysStateOnHookEventNewCall();
						
						nextState = STATE_OFF_HOOK;
					}
					if (!m_callControl.isFrameClient)
						incOffHook();
				}
				break;
				case LineEvent.EVENT_REDIAL:
				{
					OPTrace.debug("STATE_ON_HOOK : Redial " +  m_lastNumberDialed);
					if(m_lastNumberDialed.length)
					{
						displaySoftKeysStateOnHookEventRedial();
						setTargetNumber(m_lastNumberDialed);
						m_callControl.dial(getCallControlLine(), getTargetNumber());
						
						nextState = STATE_OFF_HOOK;
						loadContacts();
					}
					if (!m_callControl.isFrameClient)
						incOffHook();
				}
				break;
				case LineEvent.EVENT_BACKSPACE:
				{
					OPTrace.debug("EVENT_BACKSPACE : m_targetNumber = " + m_targetNumber);
					
					m_targetNumber = m_targetNumber.substring(0, m_targetNumber.length-1);
					
					if(m_targetNumber.length > 0)
						displaySoftKeysStateOnHookEventBackSpace(true);
					else
						displaySoftKeysStateOnHookEventBackSpace(false);
					setTargetName("");
					//OPTrace.debug("m_targetNumber = " + m_targetNumber);
					loadContacts();
				}
				break;
				case LineEvent.EVENT_ATRANSFER:
				{
					OPTrace.debug("STATE_ON_HOOK : EVENT_ATRANSFER");
					m_inTransfer = true;
				}
				break;
				case LineEvent.EVENT_HOOK_FLASH:
				{
					displaySoftKeysStateOffHookEventOffHook(true);
					nextState = STATE_OFF_HOOK;
					incOffHook();
				}
				break;
				case LineEvent.EVENT_EXIT_STATE:
				{
					OPTrace.debug("STATE_ON_HOOK : EVENT_EXIT_STATE");
				}
				break;
				case LineEvent.EVENT_IGNORE:
				{
					m_callControlLine.account.stopRingback();
					m_callControl.ignore(getCallControlLine());
					displaySoftKeysStateIncomingCallEventIgnore();
					nextState = STATE_ON_HOOK;
				}
				break;
				case LineEvent.EVENT_ANSWER: //call waiting during incoming call event
				{
					m_callControlLine.account.stopRingback();
					
					//m_callControl.offhook(getCallControlLine());
					
					displaySoftKeysStateIncomingCallEventAnswer();
					m_incoming = true;
					nextState = Line.STATE_CONNECTED;
					if (!m_callControl.isFrameClient)
						incOffHook();
				}
				break;
				}
			}
			break;
			case STATE_OFF_HOOK:
			{
				OPTrace.debug("STATE_OFF_HOOK");
				
				switch(event.m_eventId)
				{
   				case LineEvent.EVENT_NEW_CALL:
				{
                    //This should only happen when HS is offhook and gui isnt
                    m_callControl.offhook(getCallControlLine());
					displaySoftKeysStateOnHookEventNewCall();
					incOffHook();
				}
				break;
				case LineEvent.EVENT_ENTER_STATE:
				{
					m_errorString = "";
					break;
				}
				case LineEvent.EVENT_DIGIT:
				{
					//digitEvent = DigitLineEvent(event);
					m_callControl.digit(getCallControlLine(), event.m_digit);
					m_targetNumber = m_targetNumber.concat(event.m_digit);
					setTargetName("");
					loadContacts();
				}
				break;
				case LineEvent.EVENT_FOCUS_LOST:
				case LineEvent.EVENT_END_CALL:
				{
					decOffHook();
					m_callControl.onhook(getCallControlLine());
					
					// This event handler implies GUI surfaced the event.
					if(m_offHookCounter == 0)
					{
						displaySoftKeysStateOffHookEventEndCall();
						nextState = STATE_ON_HOOK;
					}
					else
						displaySoftKeysStateOffHookEventEndCallJoin();
				}
				break;
				case LineEvent.EVENT_JOIN:
				{
					m_callControl.offhook(getCallControlLine());

					displaySoftKeysStateOffHookEventJoin();

					nextState = STATE_OFF_HOOK;
					incOffHook();
				}
				break;
				case LineEvent.EVENT_HOOK_FLASH:
					m_callControl.hookFlash(getCallControlLine(), event.m_duration);
					displaySoftKeysStateOffHookEventOnHook();
					nextState = STATE_ON_HOOK;
					decOffHook();
				break;
				}
			}
			break;
			case STATE_INCOMING_CALL:
			{
				switch(event.m_eventId)
				{
				//case LineEvent.EVENT_NEW_CALL:
				case LineEvent.EVENT_HOOK_FLASH:
					OPTrace.debug("INCOMING: RECVD HOOKFLASH");
					// start duration should be handled by connected event
					startDuration();
					m_incoming = true;
					m_callControlLine.account.stopRingback();
					displaySoftKeysStateIncomingCallEventAnswer();
					nextState = Line.STATE_CONNECTED;
					incOffHook();
				break;
				case LineEvent.EVENT_ANSWER:
				{
					m_callControlLine.account.stopRingback();
					
					m_callControl.offhook(getCallControlLine());
					
					displaySoftKeysStateIncomingCallEventAnswer();
					m_incoming = true;
					nextState = Line.STATE_CONNECTED;
					if (!m_callControl.isFrameClient)
						incOffHook();
				}
				break;
				case LineEvent.EVENT_IGNORE:
				{
					if (!m_callControl.isFrameClient)
						m_callControlLine.account.stopRingback();
					m_callControl.ignore(getCallControlLine());
					displaySoftKeysStateIncomingCallEventIgnore();
					m_incoming = false;
					nextState = STATE_ON_HOOK;
				}
				break;
				}
			}
			break;
			case STATE_PROCEEDING:
			{
				switch(event.m_eventId)
				{
				case LineEvent.EVENT_END_CALL:
				{
					decOffHook();
					m_callControl.onhook(getCallControlLine());
					if(m_offHookCounter == 0)
					{
						displaySoftKeysStateProceedingEventEndCall();
						
						nextState = STATE_ON_HOOK;
					}
					else
						displaySoftKeysStateProceedingEventEndCallJoin();
				}
				break;
				case LineEvent.EVENT_JOIN:
				{
					incOffHook();
					m_callControl.offhook(getCallControlLine());
					displaySoftKeysStateProceedingEventJoin();
				}
				break;
				case LineEvent.EVENT_HOOK_FLASH:
					m_callControl.hookFlash(getCallControlLine(), event.m_duration);
					displaySoftKeysStateOffHookEventOnHook();
					decOffHook();
					nextState = STATE_ON_HOOK;
				break;
				case LineEvent.EVENT_DIGIT:
				{
					if (m_callControl.isFrameClient) {
						//digitEvent = DigitLineEvent(event);
						m_callControl.digit(getCallControlLine(), event.m_digit);
						m_targetNumber = m_targetNumber.concat(event.m_digit);
						setTargetName("");
						loadContacts();
					}
				}
				break;
				}
			}
			break;
			case STATE_REMOTE_ALERTING:
			{
				switch(event.m_eventId)
				{
					case LineEvent.EVENT_END_CALL:
					{
						decOffHook();
						m_callControl.onhook(getCallControlLine());
						if(m_offHookCounter == 0)
						{
							displaySoftKeysStateRemoteAlertingEventEndCall();

							nextState = STATE_ON_HOOK;
						}
						else
							displaySoftKeysStateRemoteAlertingEventEndCallJoin();
					}
					break;
					case LineEvent.EVENT_JOIN:
					{
						incOffHook();
						m_callControl.offhook(getCallControlLine());
						displaySoftKeysStateRemoteAlertingEventJoin();
					}
					break;
					case LineEvent.EVENT_HOOK_FLASH:
						m_callControl.hookFlash(getCallControlLine(), event.m_duration);
						displaySoftKeysStateOffHookEventOnHook();
						decOffHook();
						nextState = STATE_ON_HOOK;
					break;
					case LineEvent.EVENT_DIGIT:
					{
						//digitEvent = DigitLineEvent(event);
						m_callControl.digit(getCallControlLine(), event.m_digit);
						loadContacts();

						//Add digit to pill box for bug #6177
						if ( m_targetExtraDigits == "" )
							m_targetExtraDigits = m_targetExtraDigits.concat(":");
						m_targetExtraDigits = m_targetExtraDigits.concat(event.m_digit);
						OPTrace.debug("Added Digit " + event.m_digit);
					}
					break;
				}
			}
			break;
			case STATE_CONNECTED:
			{
				switch(event.m_eventId)
				{
				case LineEvent.EVENT_END_CALL:
				{
					decOffHook();
					m_callControl.onhook(getCallControlLine());
					
					if(m_offHookCounter == 0)
					{
						displaySoftKeysStateConnectedEventEndCall();
						nextState = STATE_ON_HOOK;
					}
					else
						displaySoftKeysStateOffHookEventEndCallJoin();
				}
				break;
				case LineEvent.EVENT_NEW_CALL:
				case LineEvent.EVENT_ANSWER:
				{
					m_callControl.offhook(getCallControlLine());
					displaySoftKeysStateOnHookEventNewCall();
					incOffHook();
				}
				break;				
				case LineEvent.EVENT_JOIN:
				{
					incOffHook();
					m_callControl.offhook(getCallControlLine());
					displaySoftKeysStateConnectedEventJoin();
				}
				break;
				case LineEvent.EVENT_FOCUS_LOST:
				case LineEvent.EVENT_HOLD:
				{
					m_callControl.hold(getCallControlLine());
					
					displaySoftKeysStateConnectedEventHold();
					
					nextState = STATE_HOLD;
				}
				break;
				case LineEvent.EVENT_ATRANSFER:
				{
					m_callControl.hold(getCallControlLine());

					displaySoftKeysStateConnectedEventHold();
					//displaySoftKeysStateConnectedEventAttendedTransfer();
					
					nextState = STATE_ATTENDED_TRANSFER;
				}
				break;
				case LineEvent.EVENT_ATRANSFER_COMPLETE: // 2nd line 
				{
					decOffHook();
					m_callControl.onhook(getCallControlLine());
					
					displaySoftKeysStateConnectedEventEndCall();
					nextState = STATE_ON_HOOK;
				}
				break;
				case LineEvent.EVENT_UTRANSFER:
				{
					m_callControl.hold(getCallControlLine());

					displaySoftKeysStateConnectedEventUnattendedTransfer();
					
					nextState = STATE_UNATTENDED_TRANSFER;
				}
				break;
				case LineEvent.EVENT_DIGIT:
				{
					//digitEvent = DigitLineEvent(event);
					m_callControl.digit(getCallControlLine(), event.m_digit);
					loadContacts();

					//Add digit to pill box for bug #6177
					if ( m_targetExtraDigits == "" )
						m_targetExtraDigits = m_targetExtraDigits.concat(":");
					m_targetExtraDigits = m_targetExtraDigits.concat(event.m_digit);
					OPTrace.debug("Added Digit " + event.m_digit);
				}
				break;
				case LineEvent.EVENT_IM:
					//callControl.message(getCallControlLine(), im.m_msg);
				break;
				case LineEvent.EVENT_HOOK_FLASH:
					OPTrace.debug("CONNECTED: RECVD HOOKFLASH");
					m_callControl.hookFlash(getCallControlLine(), event.m_duration);
					nextState = STATE_HOLD;
				break;
				}
			}
			break;
			case STATE_HOLD:
			{
				switch(event.m_eventId)
				{
				case LineEvent.EVENT_END_CALL:
				{
					decOffHook();
					m_callControl.onhook(getCallControlLine());
					
					displaySoftKeysStateHoldEventEndCall();
					
					nextState = STATE_ON_HOOK;
				}
				break;
				case LineEvent.EVENT_HOOK_FLASH:
					nextState = STATE_CONNECTED;
                    displaySoftKeysStateHoldEventResume();
				break;
				case LineEvent.EVENT_RESUME:
				{
					m_callControlLine.account.stopRingback();
					m_callControl.resume(getCallControlLine());

					displaySoftKeysStateHoldEventResume();
					
					nextState = STATE_CONNECTED;
				}
				break;
				}
			}
			break;
			case STATE_ATTENDED_TRANSFER:
			{
				switch(event.m_eventId)
				{
				case LineEvent.EVENT_ATRANSFER_COMPLETE:
				{
					decOffHook();
					m_callControl.atransfer(getCallControlLine(), Line(event.currentTarget).getLineIndex());

					displaySoftKeysStateAttendedTransferEventAttendedTransfer();

					nextState = STATE_ON_HOOK;
				}
				break;
				case LineEvent.EVENT_RESUME:
				case LineEvent.EVENT_CANCEL:
				{
					m_callControl.resume(getCallControlLine());

					displaySoftKeysStateAttendedTransferEventCancel();

					nextState = STATE_CONNECTED;
				}
				break;
				}
			}
			break;
			case STATE_UNATTENDED_TRANSFER:
			{
				switch(event.m_eventId)
				{
				case LineEvent.EVENT_DIGIT:
				{
					//digitEvent = DigitLineEvent(event);
					m_transferToNumber = m_transferToNumber.concat(event.m_digit);
					
				}
				break;
				case LineEvent.EVENT_UTRANSFER_COMPLETE:
				{
					OPTrace.debug("Unattended Transfer to " + m_transferToNumber);
					m_callControl.utransfer(getCallControlLine(), m_transferToNumber);
					
					m_transferToNumber = "";
					displaySoftKeysStateUnAttendedTransferEventTransferComplete();
					decOffHook();
					nextState = STATE_ON_HOOK;
				}
				break;
				case LineEvent.EVENT_CANCEL:
				{
					m_callControl.resume(getCallControlLine());

					m_transferToNumber = "";

					displaySoftKeysStateUnAttendedTransferEventCancel();

					nextState = STATE_CONNECTED;
				}
				break;
				}
			}
			break;
			}
			
			if(nextState)
			{
				OPTrace.debug("LINE" + getLineIndex() + "::NEXT STATE::" + nextState);
				onSoftKeyEvent(new LineEvent(LineEvent.EVENT_EXIT_STATE));
				m_currentState = nextState;
				onSoftKeyEvent(new LineEvent(LineEvent.EVENT_ENTER_STATE));
				OPTrace.debug("Line::onSoftKeyEvent : current state " + m_currentState);
			}
			
			OPTrace.debug("Line" + getLineIndex() + ".onSoftKeyEvent:m_offHookCounter(after)::" + m_offHookCounter + ", m_guiOffHook = " + m_guiOffHook);
			dispatchEvent(new LineEvent(LineEvent.EVENT_INVALIDATE_OBJECT));
		}		
	}
}
