﻿package op.extensions.phone
{
	
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	import op.external.OPTrace;

	public class ResidentialLine extends Line
	{
		private static var PRE_TRANS_LANG_JOIN:String = "JOIN";
		private var m_inBaseIntercom:Boolean = false;
		private var m_inHSIntercom:Array = null;
		private var m_inBaseIntercomAlert:Boolean = true;
		private var m_inIntercomAlertHS:String = "1";
		private var m_callControl:*;
		private var m_lineList:* = null;
		private var m_pendingFlashHook:Boolean = false;
		private var m_lastSetFHEnableState:Boolean;
		private var m_HFtimer:Timer;
		private var m_pendingEnd:Boolean = false;
		private var m_lastSetNewEnableState:Boolean;
		private var m_EndTimer:Timer;

		public function ResidentialLine(callControl:ICallControl, provider:String, account:Account, lineIndex:Number)
		{
			OPTrace.informational("ResidentialLine::Constructor");
			super(callControl, provider, account, lineIndex);
			m_callControl = callControl;
			setButtonsOnHook();

			m_HFtimer = new Timer(3000, 1);
			m_HFtimer.addEventListener(TimerEvent.TIMER, onHFTimerEnd, false, 0, true);

			m_EndTimer = new Timer(3000, 1);
			m_EndTimer.addEventListener(TimerEvent.TIMER, onEndTimerEnd, false, 0, true);
		}
		
		public function setButtonsOnHook()
		{
			if ( !m_inBaseIntercom ) {
				m_currentButtonSet = new Array();
				m_lastSetNewEnableState = true;
				if ( !m_pendingEnd )
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_NEW_CALL, enabled:true } );
				else
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_NEW_CALL, enabled:false } );
				if( m_lastNumberDialed.length )
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_REDIAL, enabled:true } );
				else
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_REDIAL, enabled:false } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_END_CALL, enabled:false } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_MUTE, enabled:false } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_HOOK_FLASH, enabled:false } );
				m_lastSetFHEnableState = false;
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_BACKSPACE, enabled:true } );
				if ( m_callControl.isFrameClient )
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_INTERCOM, enabled:false } );
				else
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_INTERCOM, enabled:true } );
			}
		}
		
		public function setButtonsOffHook()
		{
			m_currentButtonSet = new Array();
			m_lastSetNewEnableState = false;
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_NEW_CALL, enabled:false } );
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_REDIAL, enabled:false } );
			if ( m_inBaseIntercom )
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_INTERCOM_DISCONNECT, enabled:true } );
			else
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_END_CALL, enabled:true } );
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_MUTE, enabled:true } );
			if( m_callControl.accountArray[0].numberOfLines > 1 ) {
				m_lastSetFHEnableState = true;
				if ( !m_pendingFlashHook && !m_inBaseIntercom )
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_HOOK_FLASH, enabled:true } );
				else
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_HOOK_FLASH, enabled:false } );
			}
			else {
				m_lastSetFHEnableState = false;
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_HOOK_FLASH, enabled:false } );
			}
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_BACKSPACE, enabled:false } );
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_INTERCOM, enabled:false } );
		}
		
		public function setButtonsOnHookJoin()
		{
			if ( !m_inBaseIntercom ) {
				m_currentButtonSet = new Array();
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_JOIN, enabled:true } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_REDIAL, enabled:false } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_END_CALL, enabled:false } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_MUTE, enabled:false } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_HOOK_FLASH, enabled:false } );
				m_lastSetFHEnableState = false;
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_BACKSPACE, enabled:true } );
				if ( m_callControl.isFrameClient )
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_INTERCOM, enabled:false } );
				else
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_INTERCOM, enabled:true } );
			}
		}
		
		public function setButtonsOnHookIncoming()
		{
			if ( !m_inBaseIntercom ) {
				m_currentButtonSet = new Array();
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_ANSWER, enabled:true } );
				if( m_lastNumberDialed.length )
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_REDIAL, enabled:true } );
				else
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_REDIAL, enabled:false } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_IGNORE, enabled:false } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_MUTE, enabled:false } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_HOOK_FLASH, enabled:false } );
				m_lastSetFHEnableState = false;
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_BACKSPACE, enabled:true } );
				if ( m_callControl.isFrameClient )
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_INTERCOM, enabled:false } );
				else
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_INTERCOM, enabled:true } );
			}
		}
		
		public function setButtonsOnHookFlash()
		{
			if ( !m_inBaseIntercom ) {
				m_currentButtonSet = new Array();
				m_lastSetNewEnableState = true;
				if ( !m_pendingEnd )
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_NEW_CALL, enabled:true } );
				else
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_NEW_CALL, enabled:false } );
				if( m_lastNumberDialed.length )
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_REDIAL, enabled:true } );
				else
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_REDIAL, enabled:false } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_END_CALL, enabled:false } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_MUTE, enabled:false } );
				if ( m_pendingFlashHook || m_inBaseIntercom )
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_HOOK_FLASH, enabled:false } );
				else
					m_currentButtonSet.push( { eventId:LineEvent.EVENT_HOOK_FLASH, enabled:true } );
				m_lastSetFHEnableState = true;
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_BACKSPACE, enabled:true } );
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_INTERCOM, enabled:false } );
			}
		}

		public function setButtonsOffHookJoin()
		{
			m_currentButtonSet = new Array();
			m_lastSetNewEnableState = false;
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_NEW_CALL, enabled:false } );
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_REDIAL, enabled:false } );
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_END_CALL, enabled:true } );
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_MUTE, enabled:true } );
			if ( m_pendingFlashHook || m_inBaseIntercom )
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_HOOK_FLASH, enabled:false, label:PRE_TRANS_LANG_JOIN } );
			else
				m_currentButtonSet.push( { eventId:LineEvent.EVENT_HOOK_FLASH, enabled:true, label:PRE_TRANS_LANG_JOIN } );
			m_lastSetFHEnableState = true;
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_BACKSPACE, enabled:false } );
			m_currentButtonSet.push( { eventId:LineEvent.EVENT_INTERCOM, enabled:false } );
		}

		public function startPendingHF()
		{
			OPTrace.informational("ResidentialLine::startPendingHF");
			m_pendingFlashHook = true;
			m_HFtimer.start();

			//Loop through buttons to find and disable flash hook
			setButtonEnableState(LineEvent.EVENT_HOOK_FLASH, false);
		}

		public function onHFTimerEnd(e:* = null):void
		{
			OPTrace.informational("ResidentialLine::onHFTimerEnd");
			m_pendingFlashHook = false;

			//If the flash hook button would be enabled by the last setButtonsXXX call, then loop
			//   through the buttons to find and enable it.  If it would be disabled, leave it disabled
			if (m_lastSetFHEnableState) {
				setButtonEnableState(LineEvent.EVENT_HOOK_FLASH, true);
				dispatchEvent(new LineEvent(LineEvent.EVENT_INVALIDATE_OBJECT));
			}
		}

		public function startPendingEnd()
		{
			OPTrace.informational("ResidentialLine::startPendingEnd");
			m_pendingEnd = true;
			m_EndTimer.start();

			//Loop through buttons to find and disable dial
			setButtonEnableState(LineEvent.EVENT_NEW_CALL, false);
		}

		public function onEndTimerEnd(e:* = null):void
		{
			OPTrace.informational("ResidentialLine::onEndTimerEnd");
			m_pendingEnd = false;

			//If the dial (off-hook) button would be enabled by the last setButtonsXXX call, then loop
			//   through the buttons to find and enable it.  If it would be disabled, leave it disabled
			if (m_lastSetNewEnableState) {
				setButtonEnableState(LineEvent.EVENT_NEW_CALL, true);
				dispatchEvent(new LineEvent(LineEvent.EVENT_INVALIDATE_OBJECT));
			}
		}

		private function setButtonEnableState(lineEvent:Number, en:Boolean):void
		{
			for (var i:Number = 0; i < m_currentButtonSet.length; i++)
			{
				if ( m_currentButtonSet[i].eventId == lineEvent ) 
				{
					m_currentButtonSet[i].enabled = en;
					break;
				}
			}
		}

		public function get inBaseIntercom():Boolean { return m_inBaseIntercom; }		
		public function set inBaseIntercom(inter:Boolean) { m_inBaseIntercom = inter; }
		public function get inHSIntercom():Array { return m_inHSIntercom; }		
		public function set inHSIntercom(inter:Array) { m_inHSIntercom = inter; }
		public function get inBaseIntercomAlert():Boolean { return m_inBaseIntercomAlert; }		
		public function set inBaseIntercomAlert(inter:Boolean) { m_inBaseIntercomAlert = inter; }
		public function get inIntercomAlertHS():String { return m_inIntercomAlertHS; }		
		public function set inIntercomAlertHS(inter:String) { m_inIntercomAlertHS = inter; }

		public function set lineList(l:*) { m_lineList = l; }
		public function get lineList():* { return m_lineList; }
		
		// Current state: OFF HOOK, Received: On Hook event HS
		protected override function displaySoftKeysStateOffHookEventOnHook() : void { setButtonsOnHook(); }
		
		// Current state: OFF HOOK, Received: On Hook event Base
		protected override function displaySoftKeysStateOffHookEventOnHookSpkPhone() : void { setButtonsOnHook(); }

		// Current state: ON HOOK, Received: Proceeding for click2dial
		protected override function displaySoftKeysStateOffHookEventProceeding() : void { setButtonsOffHook(); }
		
		// Current state: OFF HOOK, Received: End Call
		protected override function displaySoftKeysStateOffHookEventEndCall() : void { setButtonsOnHook(); }
		
		// Current state: OFF HOOK, Received: End Join Call
		protected override function displaySoftKeysStateOffHookEventEndCallJoin() : void { setButtonsOnHookJoin(); }
		
		// Current state: OFF HOOK, Received: Join
		protected override function displaySoftKeysStateOffHookEventJoin() : void { setButtonsOffHook();  }
		
		// Current state: ON HOOK, Received: Off Hook event
		protected override function displaySoftKeysStateOffHookEventOffHook(guiTerminal:Boolean) : void { 
			if ( guiTerminal ) setButtonsOffHook();
			else {
				setButtonsOnHookJoin();
			}
		}
		
		// Current state: ON HOOK, Received: Incoming call
		protected override function displaySoftKeysStateOnHookIncomingCall() : void { setButtonsOnHookIncoming(); }
		
		// Current state: ON HOOK, Received: Digit
		protected override function displaySoftKeysStateOnHookEventDigit() : void { }
		
		// Current state: ON HOOK, Received: New Call
		protected override function displaySoftKeysStateOnHookEventNewCall() : void { setButtonsOffHook(); }
		
		// Current state: ON HOOK, Received: Redial
		protected override function displaySoftKeysStateOnHookEventRedial() : void { setButtonsOffHook(); }
		
		// Current state: ON HOOK, Received: Backspace
		protected override function displaySoftKeysStateOnHookEventBackSpace(displayBackspace:Boolean) : void { }

		
		
		
		// Current state: Incoming Call, Received: Off Hook event
		protected override function displaySoftKeysStateIncomingCallEventHook() : void { } // determine from HS or BASE
		
		// CUrrent state: Incoming Call, Received Off Hook event from handset
		protected override function displaySoftKeysStateIncomingCallEventOffHookHandset() : void { setButtonsOnHookJoin(); }
		
		// Current state: Incoming Call, Received: Disconnected
		protected override function displaySoftKeysStateIncomingCallEventDisconnected() : void { setButtonsOnHook(); }

		// Current state: Incoming Call, Received: Answer
		protected override function displaySoftKeysStateIncomingCallEventAnswer() : void { setButtonsOffHook(); }
		
		// Current state: Incoming Call, Received: Ignore
		protected override function displaySoftKeysStateIncomingCallEventIgnore() : void { setButtonsOnHook(); }
		
		// Current state: Incoming Call, Received: Connected
		protected override function displaySoftKeysStateIncomingCallEventConnected() : void {
			setButtonsOnHookJoin();
		}
		
		
		// Current state: Proceeding, Received: End Call
		protected override function displaySoftKeysStateProceedingEventEndCall() : void { setButtonsOnHook(); }
		
		// Current state: Proceeding, Received: End Join Call
		protected override function displaySoftKeysStateProceedingEventEndCallJoin() : void { setButtonsOnHookJoin(); }
		
		// Current state: Proceeding , Received: Connected
		protected override function displaySoftKeysStateProceedingEventConnected(transferInProgress:Boolean) : void { }

		// Current state: Proceeding, Received: Remote Alerting from Click2dial
		//protected override function displaySoftKeysStateProceedingEventRemoteAlerting() : void { setButtonsOffHook();  }

		// Current state: Proceeding, Received: Join
		protected override function displaySoftKeysStateProceedingEventJoin() : void { setButtonsOffHook(); }
		
		
		// Current state: Remote alerting, Received: End Call
		protected override function displaySoftKeysStateRemoteAlertingEventEndCall() : void { setButtonsOnHook(); }
		
		// Current state: Remote alerting, Received: End Join Call
		protected override function displaySoftKeysStateRemoteAlertingEventEndCallJoin() : void { setButtonsOnHookJoin(); }
		
		protected override function setInBaseIntercom(baseInIntercom:Boolean) : void { m_inBaseIntercom = baseInIntercom;  }
		
		protected override function getInBaseIntercom() : Boolean { return m_inBaseIntercom; }
		
		// Current state: Remote alerting, Received: Connected
		protected override function displaySoftKeysStateRemoteAlertingEventConnected(transferInProgress:Boolean) : void 
		{
			if ( !this.m_guiOffHook ) { // HS is remote alerting
				setButtonsOnHookJoin();
			}
		}

		// Current state: Remote Alerting, Received: Error
		protected override function displaySoftKeysStateRemoteAlertingEventError() : void { }
		
		// Current state: Remote Alerting, Received: Join
		protected override function displaySoftKeysStateRemoteAlertingEventJoin() : void {  setButtonsOffHook(); }
		
		
		
		// Current state: Connected, Received: End Call
		protected override function displaySoftKeysStateConnectedEventEndCall() : void { setButtonsOnHook(); }
		
		// Current state: Connected, Received: Hold
		protected override function displaySoftKeysStateConnectedEventHold() : void { }
		
		// Current state: Connected, Received: Attended Transfer
		//protected override function displaySoftKeysStateConnectedEventAttendedTransfer() : void {}
		
		// Current state: Connected, Received: Unattended Transfer
		//protected override function displaySoftKeysStateConnectedEventUnattendedTransfer() : void {}

		// Current state: Connected, Received: Disconnected
		protected override function displaySoftKeysStateConnectedEventDisconnected() : void { setButtonsOnHook(); }
		
		// Current state: Connected, Received: Join
		protected override function displaySoftKeysStateConnectedEventJoin() : void { setButtonsOffHook();		}
		
		
		
		// Current state: Hold, Received: Disconnected
		protected override function displaySoftKeysStateHoldEventOnHook() : void { setButtonsOnHook(); }
		
		// Current state: Hold, Received: End Call
		protected override function displaySoftKeysStateHoldEventEndCall() : void { setButtonsOnHook(); }
		
		// Current state: Hold, Received: Resume
		protected override function displaySoftKeysStateHoldEventResume() : void { setButtonsOffHook(); }
		
		
		
		// Current state: Attended Transfer
		//protected override function displaySoftKeysStateAttendedTransferEventAttendedTransfer() : void {}
		//protected override function displaySoftKeysStateAttendedTransferEventCancel() : void { }
		
		// Current state: Unattended Transfer
		//protected override function displaySoftKeysStateUnAttendedTransferEventTransferComplete() : void {}		
		//protected override function displaySoftKeysStateUnAttendedTransferEventCancel() : void {}

	}
	
}
