﻿package op.extensions.phone.events
{
	import flash.events.*;
		

		
	public class CallControlErrorEvent extends CallControlEvent
	{
		private const TRYING_100:Number = 0;
		private const REMOTE_ALERTING_180:Number = 1;
		private const CALL_FORWARDED_181:Number = 2;
		private const QUEUED_182:Number = 3;
		private const SESSION_PROGRESS_183:Number = 4;
	
		private const SUCCESS_200:Number = 5;
		private const ACCEPTED_202:Number = 6;
	
		private const REDIRECTED_300:Number = 7;
		private const MOVED_PERMANENTLY_301:Number = 8;
		private const MOVED_TEMPORARILY_302:Number = 9;
		private const USE_PROXY_305:Number = 10;
		private const ALTERNATIVE_SERVICE_380:Number = 11;
	
		private const BAD_REQUEST_400:Number = 12;
		private const UNAUTHORIZED_401:Number = 13;
		private const PAYMENT_REQUIRED_402:Number = 14;
		private const FORBIDDEN_403:Number = 15;
		private const NOT_FOUND_404:Number = 16;
		private const METHOD_NOT_ALLOWED_405:Number = 17;
		private const NOT_ACCEPTABLE_406:Number = 18;
		private const PROXY_AUTHENTICATION_REQUIRED_407:Number = 19;
		private const REQUEST_TIMED_OUT_408:Number = 20;
		private const GONE_410:Number = 21;
		private const REQUEST_ENTITY_TOO_LARGE_413:Number = 22;
		private const REQUEST_URI_TOO_LONG_414:Number = 23;
		private const UNSUPPORTED_MEDIA_TYPE_415:Number = 24;
		private const UNSUPPORTED_URI_SCHEME_416:Number = 25;
		private const BAD_EXTENSION_420:Number = 26;
		private const EXTENSION_REQUIRED_421:Number = 27;
		private const INTERVAL_TOO_BRIEF_423:Number = 28;
		private const TEMPORARILY_UNAVAILABLE_480:Number = 29;
		private const CALL_TRANSACTION_DOES_NOT_EXIST_481:Number = 30;
		private const LOOP_DETECTED_482:Number = 31;
		private const TOO_MANY_HOPS_483:Number = 32;
		private const ADDRESS_INCOMPLETE_484:Number = 33;
		private const AMBIGUOUS_485:Number = 34;
		private const BUSY_HERE_486:Number = 35;
		private const REQUEST_TERMINATED_487:Number = 36;
		private const REQUEST_NOT_ACCEPTABLE_HERE_488:Number = 37;
		private const REQUEST_PENDING_491:Number = 38;
		private const UNDECIPHERABLE_493:Number = 39;
	
		private const SERVER_INTERNAL_ERROR_500:Number = 40;
		private const NOT_IMPLEMENTED_501:Number = 41;
		private const BAD_GATEWAY_502:Number = 42;
		private const SERVICE_UNAVAILABLE_503:Number = 43;
		private const SERVER_TIMED_OUT_504:Number = 44;
		private const VERSION_NOT_SUPPORTED_505:Number = 45;
		private const MESSAGE_TOO_LARGE_513:Number = 46;
	
		private const BUSY_EVERYWHERE_600:Number = 47;
		private const DECLINED_603:Number = 48;
		private const DOES_NOT_EXIST_ANYWHERE_604:Number = 49;
		private const NOT_ACCEPTABLE_606:Number = 50;
	
		private const UNKNOWN_XXX:Number = 51;		
		private var m_errorMsg:String = null;
		
		public function CallControlErrorEvent(errorMsg:Number)
		{
			super(CallControlEvent.CC_EVENT_LINE);
			
			switch(errorMsg)
			{
			case TRYING_100:
				m_errorMsg = "Trying";
				break;
			case REMOTE_ALERTING_180:
				m_errorMsg = "Remote Alerting";
				break;
			case CALL_FORWARDED_181:
				m_errorMsg = "Forwarded";
				break;
			case QUEUED_182:
				m_errorMsg = "Queued";
				break;
			case SESSION_PROGRESS_183:
				m_errorMsg = "Sessipn Progress";
				break;

			case SUCCESS_200:
				m_errorMsg = "Success";
				break;
			case ACCEPTED_202:
				m_errorMsg = "Accepted";
				break;

			case REDIRECTED_300:
				m_errorMsg = "Redirected";
				break;
			case MOVED_PERMANENTLY_301:
				m_errorMsg = "Moved Permanently";
				break;
			case MOVED_TEMPORARILY_302:
				m_errorMsg = "Moved Temporarily";
				break;
			case USE_PROXY_305:
				m_errorMsg = "Use Proxy";
				break;
			case ALTERNATIVE_SERVICE_380:
				m_errorMsg = "Alternatve Service";
				break;

			case BAD_REQUEST_400:
				m_errorMsg = "Bad Request";
				break;
			case UNAUTHORIZED_401:
				m_errorMsg = "Unauthorized";
				break;
			case PAYMENT_REQUIRED_402:
				m_errorMsg = "Payment Required";
				break;
			case FORBIDDEN_403:
				m_errorMsg = "Forbidden";
				break;
			case NOT_FOUND_404:
				m_errorMsg = "Not Found";
				break;
			case METHOD_NOT_ALLOWED_405:
				m_errorMsg = "Method Not Allowed";
				break;
			case NOT_ACCEPTABLE_406:
				m_errorMsg = "Not Acceptable";
				break;
			case PROXY_AUTHENTICATION_REQUIRED_407:
				m_errorMsg = "Proxy Authentication Required";
				break;
			case REQUEST_TIMED_OUT_408:
				m_errorMsg = "Request Timed Out";
				break;
			case GONE_410:
				m_errorMsg = "Gone";
				break;
			case REQUEST_ENTITY_TOO_LARGE_413:
				m_errorMsg = "Request Entity Too Large";
				break;
			case REQUEST_URI_TOO_LONG_414:
				m_errorMsg = "Request URI Too Long";
				break;
			case UNSUPPORTED_MEDIA_TYPE_415:
				m_errorMsg = "Unsupported Media Type";
				break;
			case UNSUPPORTED_URI_SCHEME_416:
				m_errorMsg = "Unsupported URI Scheme";
				break;
			case BAD_EXTENSION_420:
				m_errorMsg = "Bad Extension";
				break;
			case EXTENSION_REQUIRED_421:
				m_errorMsg = "Extension Required";
				break;
			case INTERVAL_TOO_BRIEF_423:
				m_errorMsg = "Interval Too Brief";
				break;
			case TEMPORARILY_UNAVAILABLE_480:
				m_errorMsg = "Temporarily Unavailable";
				break;
			case CALL_TRANSACTION_DOES_NOT_EXIST_481:
				m_errorMsg = "Call/Transaction Does Not Exist";
				break;
			case LOOP_DETECTED_482:
				m_errorMsg = "Loop Dected";
				break;
			case TOO_MANY_HOPS_483:
				m_errorMsg = "Too Many Hops";
				break;
			case ADDRESS_INCOMPLETE_484:
				m_errorMsg = "Address Incomplete";
				break;
			case AMBIGUOUS_485:
				m_errorMsg = "Ambiguous";
				break;
			case BUSY_HERE_486:
				m_errorMsg = "Busy Here";
				break;
			case REQUEST_TERMINATED_487:
				m_errorMsg = "Request Terminated";
				break;
			case REQUEST_NOT_ACCEPTABLE_HERE_488:
				m_errorMsg = "Request Not Acceptable Here";
				break;
			case REQUEST_PENDING_491:
				m_errorMsg = "Rquest Pending";
				break;
			case UNDECIPHERABLE_493:
				m_errorMsg = "Undecipherable";
				break;

			case SERVER_INTERNAL_ERROR_500:
				m_errorMsg = "Server Internal Error";
				break;
			case NOT_IMPLEMENTED_501:
				m_errorMsg = "Not Implemented";
				break;
			case BAD_GATEWAY_502:
				m_errorMsg = "Trying";
				break;
			case SERVICE_UNAVAILABLE_503:
				m_errorMsg = "Trying";
				break;
			case SERVER_TIMED_OUT_504:
				m_errorMsg = "Server Timed Out";
				break;
			case VERSION_NOT_SUPPORTED_505:
				m_errorMsg = "Version Not Supported";
				break;
			case MESSAGE_TOO_LARGE_513:
				m_errorMsg = "Message Too Large";
				break;

			case BUSY_EVERYWHERE_600:
				m_errorMsg = "Busy Everywhere";
				break;
			case DECLINED_603:
				m_errorMsg = "Declined";
				break;
			case DOES_NOT_EXIST_ANYWHERE_604:
				m_errorMsg = "Does Not Exist Anywhere";
				break;
			case NOT_ACCEPTABLE_606:
				m_errorMsg = "Not Acceptable";
				break;
			case UNKNOWN_XXX:
				m_errorMsg = "Unknown";
				break;
			default:
				break;
			}			
		}
		
		public function getErrorMessage() : String
		{
			return m_errorMsg;
		}
	}
}
