﻿package op.external
{
	import flash.events.EventDispatcher;
	import flash.system.*;
	import flash.external.*;
	import op.external.*;

	public class OPClassModuleInstance extends EventDispatcher
	{
		private static var _instances:* = null;
	
		public var className:String; // Can't use under bars here, AS2 passes names with underbars instead of getter names like AS3 does :(
		public var uniqueId:String;
		public var _className:String; // Can't use under bars here, AS2 passes names with underbars instead of getter names like AS3 does :(
		public var _uniqueId:String;
		
		//========================================================
		//
		//========================================================
		public function OPClassModuleInstance(classNameIn:String, ... args)
		{
			// In-case the OPClassModuleManager was not started
			//OPClassModuleManager.start();

			//OPTrace.informational("OPClassModuleInstance::OPClassModuleInstance(" + classNameIn + ", " + args + ")");
		
			className = classNameIn;
			_className = classNameIn;
			
			var result = OPExternalInterface.call("OPClassModuleManager.createInstance", _className, args);
			if (typeof(result) == "string")
			{
				uniqueId  = result.toString();
				_uniqueId = result.toString();
				_instances[uniqueId] = this;
			} else {
				//OPTrace.informational("failed to create new instance of class " + _className + "!");
			}
		}
		
		//========================================================
		//
		//========================================================
		public function destroy():void
		{
			try
			{
				OPExternalInterface.call("OPClassModuleManager.destroyInstance", _className, _uniqueId);	
			} catch (e:Error) {
				//OPTrace.informational("OPClassModuleInstance::Unable to destroy instance of " + _className + ", " + _uniqueId);
			}
			
			_instances[uniqueId] = null;
			
		}
		
		//========================================================
		//getters and setters to link between application domains
		//========================================================
		public static function get instances():*
		{
			return null;
		}
		
		public static function set instances(arr:*):void
		{
			if (_instances == null)
				_instances = arr;
		}
		
	}
}
