﻿package op.framework
{
	import flash.net.URLLoader;
	import flash.net.URLRequest;	
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IOErrorEvent;
	import op.external.OPTrace;
	
	public final class OPLang
	{
		private static var key:String;
		private static var stringTable:XML;
		private static var uri:String;
		private static var loaded:Boolean = false;

		public static function set language(str:String)
		{
			key = str;
		}
		
		public static function get language():String
		{
			return key;
		}
		
		public static function loadLangXML(path:String, lang:String, listener:Function)
		{
			//OPTrace.informational("OPLang::loadLangXML::path="+path+", key="+key);
			key = lang;
			
			var ldr = new URLLoader();
			ldr.addEventListener(Event.COMPLETE, langComplete, false, 0, true);
			ldr.addEventListener(Event.COMPLETE, listener, false, 0, true);
			ldr.addEventListener(IOErrorEvent.IO_ERROR, langError, false, 0, true); 
			ldr.load(new URLRequest(path));
		}
		
		public static function langComplete(e:Event)
		{
			//OPTrace.informational("OPLang::onLanguageComplete");
			try
			{
				stringTable = XML(e.target.data);
				loaded = true;
			} catch (e:Error) {
				//OPTrace.informational("OPLang::onLanguageComplete:: invalid xml :: e = " + e.toString() );
				loaded = false;
			}
			
		}
		
		public static function langError(e:IOErrorEvent)
		{
			//OPTrace.informational("OPLang::onLanguageError:: no language.xml file at specified location");
			loaded = false;
		}
		
		public static function translate(id:String):String
		{
			//OPTrace.informational("OPLang::translate");
			if (loaded)
			{
				var trans:String = "";

				if ( id != null && id.length > 0 )
				{
					//make sure the id is in the table
					var elem:XMLList = stringTable[id];
					if ( elem.length() > 0 )
					{
						//make sure the language(key) attribute is present
						var attr:XMLList = elem[0].attribute(key);
						if ( attr.length() > 0 )
						{
							trans = String( attr[0] );
						}
						else //desired language not present, return the first trans in the list that is not ""
						{
							var attrs:XMLList = elem[0].@ * ;
							for (var i:int = 0; i < attrs.length(); i++)
							{
								trans = String( attrs[i] );
								if ( trans.length > 0)
									break;
							}
						}
					}
				} //end id

				return trans;
			} //end loaded
			
			return "";
		}
		
	}
	
}