﻿package op.framework
{
	import flash.display.Loader;
	import flash.events.Event;
	import flash.system.ApplicationDomain;
	import flash.utils.ByteArray;
	import op.external.OPTrace;
	
	public final class OPLink
	{
		private static var session:* = null;
		private static var app:* = null;
		private static var apploc:*= null;
		private static var so:*= null;
		private static var loadAccess:* = null;
		private static var id:* = null;
		
		public static function set application(obj:*):void
		{
			//do not allow an application to be overridden
			if (app == null && obj != null && loadAccess)
			{
				//log application entry
				OPTrace.informational("OPLink.application :: setting application");
				
				if (id)
				{
					var SystemUtils:Class = classDefinition("system", "SystemUtils") as Class
					var utils:* = new SystemUtils;
					utils.log( String(id), SystemUtils.LOG_ACTION_ENTER, "Entering " + String(id));
				}
				
				//assign application loader to app
				app = obj;
			}
		}
		
		public static function set applicationID(str:*):void
		{
			if (id == null)
				id = str;
		}
		
		public static function get application():*
		{
			return app;
		}
		
		public static function set applicationDirectory(s:*):void
		{
			if(apploc == null)
				apploc = s;
		}
		
		public static function get applicationDirectory():*
		{
			return apploc;
		}
		
		public static function get applicationID():*
		{
			return id != null ? id : "";
		}
		
		public static function closeApplication():void
		{
			trace("OPLink closeApplication1" + app);
			
			if(app != null)
				session.desktop.removeApplication(app);
		}
		
		public static function get commonDirectory():String
		{
			return session.commonDir;
		}		
		
		public static function set link(obj:*):void
		{
			if (session == null)
				session = obj;
		}
		
		public static function get link():*
		{
			return null;
		}
		
		public static function loadApplication(file:String, args:* = null):void
		{
			/*
				desc: pushes an application on the application stack
				params:
					file: name of the application file. 
					args: parameter to pass to the new application. 
				returns:
					nothing
			*/
			
			if (loadAccess) {
				if( app == null )
					session.desktop.push(apploc + file, ApplicationDomain.currentDomain, args);
				else
					session.desktop.surface(app);
			}
		}
		
		public static function onApplicationUnload(e:*):void
		{
			//clear pointer when app is unloaded for garbage collection
			OPTrace.informational("OPLink::onApplicationUnload");
			
			//log application entry
			if (id)
			{
				var SystemUtils:Class = classDefinition("system", "SystemUtils") as Class
				var utils:* = new SystemUtils;
				utils.log( String(id), SystemUtils.LOG_ACTION_EXIT, "Exiting " + String(id));
			}
			
			//clear application pointer
			app = null;
		}
		
		public static function registerSessionEvent(event:String, callback:Function):void
		{
			session.addEventListener(event, callback, false, 0, true);
		}
		
		public static function setPermissions(...args:*):void
		{
			if (loadAccess == null)
				loadAccess = args[0];			
		}
		
// load file in framework
		public static function loadInFramework(path:String):Loader
		{
			return Loader( session.loadInFramework(path) );
		}
		
		public static function loadOneTimeApplication(path:String, args:* = null):void
		{
			var gb = session.loadInFramework(path, true, args);
		}
		
// cookie and file writer apis ==================================================
		public static function getLocal( id:String = "localCookie", enc:String = ""):*
		{
			return loadAccess ? session.getLocal(id, apploc, enc) : null; 
		}
		
		public static function getGlobal(id:String, enc:String = ""):*
		{
			return session.getLocal(id, session.commonDir, enc);
		}
		
		public static function write ( file:String, data:String, overwrite:Boolean = true ):void
		{
			session.write(apploc + file, data, overwrite);
		}
		
		public static function writeGlobal ( file:String, data:String, overwrite:Boolean = true ):void
		{
			session.write(session.commonDir + file, data, overwrite);
		}
		
		public static function writeBytes ( file:String, data:ByteArray, overwrite:Boolean = true ):void
		{
			session.writeBytes(apploc + file, data, overwrite);
		}
		
		public static function remove (file:String, overwrite:Boolean = true):void
		{
			session.remove(apploc + file, overwrite);
		}
		
// flash shared library methods =================================================
		public static function get definitions():Object
		{
			return session.definitions as Object;
		}
		
		public static function classDefinition(lib:String, className:String):Class
		{
			//check if class comes from o2components
			if (lib == "components" && className.charAt(1) != "P")
				lib = "o2components";
			
			return session.definitions[lib].getDefinition(className) as Class;
		}
		
// titlebar access ==============================================================

		public static function sendTitlebarCommand( cmd:String, ...args:*):void
		{
			trace("OPLink::sendTitlebarCommand:: cmd = " + cmd + ", args.length = " + args.length);
			session.titlebar.receiveCommand( cmd, args );	
		}
		
// mainmenu access ============================================================== (Rey)

		public static function sendMainMenuCommand( cmd:String, ...args:*):void
		{
			trace("OPLink::sendMainMenuCommand:: cmd = " + cmd + ", args.length = " + args.length);
			try{
				session.mainmenu.receiveCommand( cmd, args );
			}catch (e:Error) {
				session.instance.mainmenu.receiveCommand( cmd, args );
			}
		}

// framework translation access =================================================
		public static function translate( id:String ):String
		{
			return session.translate( id );
		}
		
// session information methods ==================================================
		public static function get brightness():int
		{
			return session.brightness;
		}
		
		public static function set brightness(val:int):void
		{
			session.brightness = val;
		}

		public static function get dateFormat():*
		{
			return session.dateFormat;
		}
		
		public static function set dateFormat(s:*):void
		{
			session.dateFormat = s;
		}

		public static function get language():*
		{
			return session.language;
		}
		
		public static function set language(s:*):void
		{
			session.language = s;
		}
		
		public static function get region():*
		{
			return session.region;
		}
		
		public static function get timeFormat():*
		{
			return session.timeFormat;
		}
		
		public static function set timeFormat(s:*):void
		{
			trace("OPLink timeformat"+s);
			session.timeFormat = s;
		}
		
		public static function get volume():*
		{
			return session.volume;
		}
		
		public static function set volume(v:*):void
		{
			session.volume = v;
		}
		
		public static function get powerSavingMode():*
		{
			return session.powerSavingMode;
		}
		
		public static function set powerSavingMode(s:*):void
		{
			session.powerSavingMode = s;
		}
		
// screensaver methods ==========================================================

		public static function testScreensaver( id:String ):void
		{
			session.screensaver.test(id);
		}
		
		public static function set screensaverId( id:String ):void
		{
			session.screensaverId = id;
		}
		
		public static function get screensaverId():String
		{
			return session.screensaverId;
		}
		
		public static function set screensaverInterval( val:uint ):void
		{
			if (15000 <= val)
				session.screensaverInterval = val;			
		}
		
		public static function get screensaverInterval():uint
		{
			return session.screensaverInterval;
		}
		
		public static function addScreensaverHold():void
		{
			session.screensaver.addHold();
		}
		
		public static function removeScreensaverHold():void
		{
			session.screensaver.removeHold();
		}
		
		public static function get screensaversDir():String
		{
			return session.screensaversDir;
		}
		
// advanced component methods ===================================================

		public static function loadDownloadManager(args:*):void
		{
			session.desktop.loadDownloadManager(args);
		}
		
		public static function loadMoviePlayer(args:*):void
		{
			session.desktop.loadMoviePlayer(args);
		}
		
		public static function loadSlideshow(args:*):void
		{
			session.desktop.loadSlideshow(args);
		}

		/**
		 * 
		 * @param	s OPSound object
		 */
		public static function loadVolumeControls(OPSoundObj:* = null):void
		{
			OPTrace.informational("OPLink loadVolumeControls!!!!!!!!!!!!!!!!!! 1");
			try {
				session.desktop.loadVolumeComponent(OPSoundObj);
				
				// set this sound object in the sound manager
				var temp:Class = OPLink.classDefinition("media", "OPSoundManager") as Class;
				var OPSoundManagerObj:* = Object(temp).getInstance();
					
				OPSoundManagerObj.volumeControlObject = OPSoundObj;
					
				
				
			}catch (e:Error) {
				OPTrace.debug("OPLink::failed to load volume controls: " + e.errorID);
			}
			
			
		}
		
// clean up ====================================================================
		public static function destroyDomain()
		{
			
			
		}
		
	}
	
}