﻿package op.utils
{
	/**********************************************************
	 * desc: A base class definition for a library MovieClip that 
	 * implements a button with a dynamic label that alternates 
	 * black and white colors on mouse events. This class assumes 
	 * that the following assets are sitting on the stage at 
	 * frame 1 of the asset’s local timeline:
	 * 		
	 * TextField, id = lbl_txt 
	 * SimpleButton, id = btn
	 * 
	 */
	
	import flash.display.MovieClip;
	import flash.display.SimpleButton;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	
	public class OPBtnI extends MovieClip
	{
		private var downColor:uint = 0x000000;
		private var upColor:uint = 0xFFFFFF;
		private var outColor:uint = 0xFFFFFF;
		
		function OPBtnI()
		{
			stop();
			var txt:TextField = lbl_txt;
			txt.mouseEnabled = false;
			txt.embedFonts = true;
			
			addEventListener(MouseEvent.MOUSE_DOWN, onDown, false, 1, true);
			addEventListener(MouseEvent.MOUSE_UP, onUp, false, 1, true);
			addEventListener(MouseEvent.MOUSE_OUT, onOut, false, 1, true);
		}
		
		public function set lbl(str:String)
		{
			lbl_txt.text = str;
		}
		
		public function get lbl():String
		{
			return lbl_txt.text;
		}
		
		public function onDown(e:MouseEvent)
		{
			lbl_txt.textColor = downColor;
		}
		
		public function onOut(e:MouseEvent)
		{
			lbl_txt.textColor = outColor;
		}
		
		public function onUp(e:MouseEvent)
		{
			lbl_txt.textColor = upColor;
		}
		
		public override function set enabled(b:Boolean):void
		{
			alpha = b ? 1 : .25;
			mouseEnabled = b;
			mouseChildren = b;
			super.enabled = b;
		}
		
		public function set downTxtColor(color:uint)
		{
			downColor = color;
		}
		
		public function set upTxtColor(color:uint)
		{
			upColor = color;
		}

		public function set outTxtColor(color:uint)
		{
			outColor = color;
		}

		public function get downTxtColor():uint
		{
			return downColor;
		}
		
		public function get upTxtColor():uint
		{
			return upColor;
		}

		public function get outTxtColor():uint
		{
			return outColor;
		}

	}
	
}
