﻿package op.utils
{
	/**********************************************************
	 *  desc: A base class definition for a library MovieClip 
	 * that implements a button with two states and a dynamic 
	 * label.  This class assumes the library asset has key 
	 * frames at frame 1 and 2 of the asset’s local timeline 
	 * representing the inactive and active states respectively.  
	 * 
	 * Additionally the asset must contain the following on layer 
	 * that spans the state key frames:
	 * 
	 * TextField, id = lbl_txt
	 * 
	 */
	
	import flash.display.MovieClip;
	import flash.display.SimpleButton;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	
	public class OPBtnToggleWT extends MovieClip
	{

		function OPBtnToggleWT()
		{
			stop();
			var txt:TextField = lbl_txt;
			txt.mouseEnabled = false;
			txt.embedFonts = true;
		}
		
		public function set lbl(str:String)
		{
			lbl_txt.text = str;
		}
		
		public function get lbl():String
		{
			return lbl_txt.text;
		}
		
		public function set lbl_html(str:String)
		{
			lbl_txt.htmlText = str;
		}
		
		public function get lbllbl_html():String
		{
			return lbl_txt.htmlText;
		}
		
		public function get isOn():Boolean
		{
			return currentFrame == 2;
		}
		
		public function set isOn(b:Boolean)
		{
			gotoAndStop(b?2:1);
		}
		
		public override function set enabled(b:Boolean):void
		{
			alpha = b ? 1 : .25;
			mouseEnabled = b;
			mouseChildren = b;
			super.enabled = b;
		}
		
	}
	
}