﻿package op.utils
{
	import fl.controls.NumericStepper;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.GlowFilter;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	/**
	 * ...
	 * @author Jonathan Alaimo
	 */

	public class OPNumericStepper extends NumericStepper
	{
		private var bTrap:Boolean = false;
		private var bSlide:Boolean = false;
		private var lastY:Number;
		private var speedY:Number;
		private var count:uint;
		private var accel:Number = 8;
		private var deccel:Number = 0.90;
		private var startDelta:Number = 3;		
		private var rate:uint;
		
		public function OPNumericStepper(tf:TextFormat=null)
		{
			super();
			//set background
			var bg:Sprite = new Sprite();			
			bg.graphics.beginFill(0xEBEBEB, 1);
			bg.graphics.drawRect(0, 0, 1, 1);
			bg.graphics.endFill();
			
			if (tf == null)
			{
				tf = new TextFormat();
				tf.size = 96;
				tf.font = "Arial";
				tf.color = 0x757A7E;
				tf.align = TextFormatAlign.CENTER;
			}
			
			setStyle("TextInput_upskin", bg);
			setStyle("focusRectSkin", new Sprite() );
			setStyle("embedFonts", true);
			setStyle("textFormat", tf);
			setStyle("upArrowUpSkin", new Sprite());
			setStyle("upArrowOverSkin",new Sprite() );
			setStyle("upArrowDownSkin", new Sprite());
			setStyle("upArrowDisabledSkin", new Sprite() );
			setStyle("downArrowUpSkin", new Sprite());
			setStyle("downArrowOverSkin", new Sprite());
			setStyle("downArrowDownSkin", new Sprite());
			setStyle("downArrowDisabledSkin", new Sprite());		
			
			this.textField.textField.selectable = false;
			this.mouseChildren = false;

			filters = [new GlowFilter(0x000000, 0.75, 0, 20 , 2 , 3, true, false) , new GlowFilter(0x000000, 0.75, 0, 5 , 2 , 3, true, false)  ];
			addEventListener(MouseEvent.MOUSE_DOWN, onDown, false, 0, true);
		}
		
		private function onDown(e:MouseEvent)
		{
			mouseChildren = true;
			
			bTrap = false;
			bSlide = false;
			
			lastY = mouseY;
			speedY = 0;
			count = 1;
			
			stage.addEventListener(MouseEvent.MOUSE_UP, onUp, false, 0, true);
			stage.addEventListener(MouseEvent.MOUSE_MOVE, onMove, false, 0, true);
		}
		
		private function onFrame(e:Event)
		{
			if (bSlide)
			{
				
				speedY *= deccel;
				
				if (Math.abs (speedY) < 1)
				{
					bSlide = false;
					mouseChildren = true;
					removeEventListener(Event.ENTER_FRAME, onFrame);
				} else { 
					updateValue();
				}
							
			} else {
				
				speedY *= 0.25;
			
			}

		}
		
		private function onMove(e:MouseEvent)
		{
			var difference = this.mouseY - lastY;
			
			if (bTrap)
			{
				
				speedY += difference;
				lastY = mouseY;
				count++;
				
				if ( 1 < Math.abs(difference) )
					updateValue();
					
			} else if (startDelta < Math.abs(difference) ){
			
				bTrap = true;
				mouseChildren = false;
				addEventListener(Event.ENTER_FRAME, onFrame, false, 0, true);
			}
		}
		
		private function onUp(e:MouseEvent)
		{
			if (!bSlide)
			{
				trace("onUp :: not sliding");
				
				stage.removeEventListener(MouseEvent.MOUSE_MOVE, onMove);
				stage.removeEventListener(MouseEvent.MOUSE_UP, onUp);
			
				bTrap = false;
				
				speedY += mouseY - lastY;
				speedY = (speedY * accel) / count;
			
				if ( speedY )
				{
					bSlide = true;
				} else {
					mouseChildren = true;
					removeEventListener(Event.ENTER_FRAME, onFrame);
				}
			}
		}
		
		private function updateValue()
		{
			if (0 < speedY)
				value =  value != this.minimum ? this.previousValue : this.maximum; 
			else 
				value =  value != this.maximum ? this.nextValue : this.minimum;
			
			dispatchEvent( new Event(Event.CHANGE) );
		}
		
	}
	
}