﻿package op.utils
{
	/**********************************************************
	 * desc: Subclass of the List component designed to enforce 
	 * a common set of styles.  This class assumes the following assets are in the application’s library:
	 * 
	 *  + Flash List component
	 *  + A set of MovieClips that define the scrollbar skin.  
	 *    These must be exported for use in ActionScript as OPSBTrack, 
	 *    OPSBThumb, OPSBThumbIcon OPSBArrowDown, OPSBArrowDownH, OPSBArrowUp, and OPSBArrowUpH
	 * 
	 *  additionally this must be compiled against the included fl package
	 */
		
	import fl.containers.ScrollPane;
	import flash.display.Sprite;
	
	public class OPScrollPane extends ScrollPane
	{
		
		public function OPScrollPane()
		{
			super();
			setStyle("embedFonts", true);
			setStyle("skin",new Sprite())
			
			setStyle("trackUpSkin",  OPSBTrack );
			setStyle("trackDownSkin", OPSBTrack );
			setStyle("trackDisabledSkin", OPSBTrack );
			setStyle("trackOverSkin", OPSBTrack );
			
			setStyle("thumbUpSkin",  OPSBThumb );
			setStyle("thumbDownSkin", OPSBThumb );
			setStyle("thumbDisabledSkin", OPSBThumb );
			setStyle("thumbOverSkin", OPSBThumb );
			setStyle("thumbIcon", OPSBThumbIcon );
			
			setStyle("upArrowUpSkin", OPSBArrowUp );
			setStyle("upArrowOverSkin", OPSBArrowUp );
			setStyle("upArrowDownSkin", OPSBArrowUpH );
			setStyle("upArrowDisabledSkin", OPSBArrowUpH );
			
			setStyle("downArrowUpSkin",OPSBArrowDown );
			setStyle("downArrowOverSkin", OPSBArrowDown);
			setStyle("downArrowDownSkin", OPSBArrowDownH );
			setStyle("downArrowDisabledSkin", OPSBArrowDownH );
			
			setStyle("scrollBarWidth", 45);
			setStyle("scrollArrowHeight", 35);
			
			verticalLineScrollSize = 20;
		}
		
	}
	
}